namespace iup


public include std/dll.e
public include std/machine.e

atom iup = open_dll({ "iup.dll", "libiup.so", "libiup.dylib" })
atom iupimglib = open_dll({ "iupimglib.dll", "libiupimglib.so", "libiupimglib.dylib" })

public constant EXIT_SUCCESS = 0
public constant EXIT_FAILURE = 1

ifdef not EU4_1 then
public function sizeof( atom ctype )
	return and_bits( ctype, #FF )
end function
end ifdef

-- opposite of allocate_string_pointer_array()
public function peek_string_pointer_array( atom ptr, atom max )
	sequence strings = {}
	atom pstr = peek_pointer( ptr )
	while pstr != NULL do
		sequence str = peek_string( pstr )
		strings = append( strings, str )
		if length( strings ) = max then
			exit
		end if
		ptr += sizeof( C_POINTER )
		pstr = peek_pointer( ptr )
	end while
	return strings
end function

-- allocate an image to memory
public function allocate_image( sequence data, integer cleanup = 0 )
	atom buff = allocate_data( length(data), cleanup )
	poke( buff, data ) return buff
end function

-- return a call_back handle for a routine
public function Icallback( sequence name, atom rid = routine_id(name) )
	return call_back({ '+', rid })
end function


public include iupkey.e
public include iupdef.e

public constant -- function delcarations
	xIupOpen                          = define_c_func( iup, "+IupOpen", {C_POINTER,C_POINTER}, C_INT ),
	xIupClose                         = define_c_proc( iup, "+IupClose", {} ),
	xIupImageLibOpen                  = define_c_proc( iupimglib, "+IupImageLibOpen", {} ),
	xIupMainLoop                      = define_c_func( iup, "+IupMainLoop", {}, C_INT ),
	xIupLoopStep                      = define_c_func( iup, "+IupLoopStep", {}, C_INT ),
	xIupLoopStepWait                  = define_c_func( iup, "+IupLoopStepWait", {}, C_INT ),
	xIupMainLoopLevel                 = define_c_func( iup, "+IupMainLoopLevel", {}, C_INT ),
	xIupFlush                         = define_c_proc( iup, "+IupFlush", {} ),
	xIupExitLoop                      = define_c_proc( iup, "+IupExitLoop", {} ),
	xIupRecordInput                   = define_c_func( iup, "+IupRecordInput", {C_POINTER,C_INT}, C_INT ),
	xIupPlayInput                     = define_c_func( iup, "+IupPlayInput", {C_POINTER}, C_INT ),
	xIupUpdate                        = define_c_proc( iup, "+IupUpdate", {C_POINTER} ),
	xIupUpdateChildren                = define_c_proc( iup, "+IupUpdateChildren", {C_POINTER} ),
	xIupRedraw                        = define_c_proc( iup, "+IupRedraw", {C_POINTER,C_INT} ),
	xIupRefresh                       = define_c_proc( iup, "+IupRefresh", {C_POINTER} ),
	xIupRefreshChildren               = define_c_proc( iup, "+IupRefreshChildren", {C_POINTER} ),
	xIupHelp                          = define_c_func( iup, "+IupHelp", {C_POINTER}, C_INT ),
	xIupLoad                          = define_c_func( iup, "+IupLoad", {C_POINTER}, C_POINTER ),
	xIupLoadBuffer                    = define_c_func( iup, "+IupLoadBuffer", {C_POINTER}, C_POINTER ),
	xIupVersion                       = define_c_func( iup, "+IupVersion", {}, C_POINTER ),
	xIupVersionDate                   = define_c_func( iup, "+IupVersionDate", {}, C_POINTER ),
	xIupVersionNumber                 = define_c_func( iup, "+IupVersionNumber", {}, C_INT ),
	xIupSetLanguage                   = define_c_proc( iup, "+IupSetLanguage", {C_POINTER} ),
	xIupGetLanguage                   = define_c_func( iup, "+IupGetLanguage", {}, C_POINTER ),
	xIupSetLanguageString             = define_c_proc( iup, "+IupSetLanguageString", {C_POINTER,C_POINTER} ),
	xIupStoreLanguageString           = define_c_proc( iup, "+IupStoreLanguageString", {C_POINTER,C_POINTER} ),
	xIupGetLanguageString             = define_c_func( iup, "+IupGetLanguageString", {C_POINTER}, C_POINTER ),
	xIupSetLanguagePack               = define_c_proc( iup, "+IupSetLanguagePack", {C_POINTER} ),
	xIupDestroy                       = define_c_proc( iup, "+IupDestroy", {C_POINTER} ),
	xIupDetach                        = define_c_proc( iup, "+IupDetach", {C_POINTER} ),
	xIupAppend                        = define_c_func( iup, "+IupAppend", {C_POINTER,C_POINTER}, C_POINTER ),
	xIupInsert                        = define_c_func( iup, "+IupInsert", {C_POINTER,C_POINTER,C_POINTER}, C_POINTER ),
	xIupGetChild                      = define_c_func( iup, "+IupGetChild", {C_POINTER,C_INT}, C_POINTER ),
	xIupGetChildPos                   = define_c_func( iup, "+IupGetChildPos", {C_POINTER,C_POINTER}, C_INT ),
	xIupGetChildCount                 = define_c_func( iup, "+IupGetChildCount", {C_POINTER}, C_INT ),
	xIupGetNextChild                  = define_c_func( iup, "+IupGetNextChild", {C_POINTER,C_POINTER}, C_POINTER ),
	xIupGetBrother                    = define_c_func( iup, "+IupGetBrother", {C_POINTER}, C_POINTER ),
	xIupGetParent                     = define_c_func( iup, "+IupGetParent", {C_POINTER}, C_POINTER ),
	xIupGetDialog                     = define_c_func( iup, "+IupGetDialog", {C_POINTER}, C_POINTER ),
	xIupGetDialogChild                = define_c_func( iup, "+IupGetDialogChild", {C_POINTER,C_POINTER}, C_POINTER ),
	xIupReparent                      = define_c_func( iup, "+IupReparent", {C_POINTER,C_POINTER,C_POINTER}, C_INT ),
	xIupPopup                         = define_c_func( iup, "+IupPopup", {C_POINTER,C_INT,C_INT}, C_INT ),
	xIupShow                          = define_c_func( iup, "+IupShow", {C_POINTER}, C_INT ),
	xIupShowXY                        = define_c_func( iup, "+IupShowXY", {C_POINTER,C_INT,C_INT}, C_INT ),
	xIupHide                          = define_c_func( iup, "+IupHide", {C_POINTER}, C_INT ),
	xIupMap                           = define_c_func( iup, "+IupMap", {C_POINTER}, C_INT ),
	xIupUnmap                         = define_c_proc( iup, "+IupUnmap", {C_POINTER} ),
	xIupResetAttribute                = define_c_proc( iup, "+IupResetAttribute", {C_POINTER,C_POINTER} ),
	xIupGetAllAttributes              = define_c_func( iup, "+IupGetAllAttributes", {C_POINTER,C_POINTER,C_INT}, C_INT ),
	xIupSetAttributes                 = define_c_func( iup, "+IupSetAttributes", {C_POINTER,C_POINTER}, C_POINTER ),
	xIupGetAttributes                 = define_c_func( iup, "+IupGetAttributes", {C_POINTER}, C_POINTER ),
	xIupSetAttribute                  = define_c_proc( iup, "+IupSetAttribute", {C_POINTER,C_POINTER,C_POINTER} ),
	xIupSetStrAttribute               = define_c_proc( iup, "+IupSetStrAttribute", {C_POINTER,C_POINTER,C_POINTER} ),
	xIupSetInt                        = define_c_proc( iup, "+IupSetInt", {C_POINTER,C_POINTER,C_INT} ),
	xIupSetFloat                      = define_c_proc( iup, "+IupSetFloat", {C_POINTER,C_POINTER,C_FLOAT} ),
	xIupSetDouble                     = define_c_proc( iup, "+IupSetDouble", {C_POINTER,C_POINTER,C_DOUBLE} ),
	xIupSetRGB                        = define_c_proc( iup, "+IupSetRGB", {C_POINTER,C_POINTER,C_UCHAR,C_UCHAR,C_UCHAR} ),
	xIupGetAttribute                  = define_c_func( iup, "+IupGetAttribute", {C_POINTER,C_POINTER}, C_POINTER ),
	xIupGetInt                        = define_c_func( iup, "+IupGetInt", {C_POINTER,C_POINTER}, C_INT ),
	xIupGetInt2                       = define_c_func( iup, "+IupGetInt2", {C_POINTER,C_POINTER}, C_INT ),
	xIupGetIntInt                     = define_c_func( iup, "+IupGetIntInt", {C_POINTER,C_POINTER,C_POINTER,C_POINTER}, C_INT ),
	xIupGetFloat                      = define_c_func( iup, "+IupGetFloat", {C_POINTER,C_POINTER}, C_FLOAT ),
	xIupGetDouble                     = define_c_func( iup, "+IupGetDouble", {C_POINTER,C_POINTER}, C_DOUBLE ),
	xIupGetRGB                        = define_c_proc( iup, "+IupGetRGB", {C_POINTER,C_POINTER,C_POINTER,C_POINTER,C_POINTER} ),
	xIupSetAttributeId                = define_c_proc( iup, "+IupSetAttributeId", {C_POINTER,C_POINTER,C_INT,C_POINTER} ),
	xIupSetStrAttributeId             = define_c_proc( iup, "+IupSetStrAttributeId", {C_POINTER,C_POINTER,C_INT,C_POINTER} ),
	xIupSetIntId                      = define_c_proc( iup, "+IupSetIntId", {C_POINTER,C_POINTER,C_INT,C_INT} ),
	xIupSetFloatId                    = define_c_proc( iup, "+IupSetFloatId", {C_POINTER,C_POINTER,C_INT,C_FLOAT} ),
	xIupSetDoubleId                   = define_c_proc( iup, "+IupSetDoubleId", {C_POINTER,C_POINTER,C_INT,C_DOUBLE} ),
	xIupSetRGBId                      = define_c_proc( iup, "+IupSetRGBId", {C_POINTER,C_POINTER,C_INT,C_UCHAR,C_UCHAR,C_UCHAR} ),
	xIupGetAttributeId                = define_c_func( iup, "+IupGetAttributeId", {C_POINTER,C_POINTER,C_INT}, C_POINTER ),
	xIupGetIntId                      = define_c_func( iup, "+IupGetIntId", {C_POINTER,C_POINTER,C_INT}, C_INT ),
	xIupGetFloatId                    = define_c_func( iup, "+IupGetFloatId", {C_POINTER,C_POINTER,C_INT}, C_FLOAT ),
	xIupGetDoubleId                   = define_c_func( iup, "+IupGetDoubleId", {C_POINTER,C_POINTER,C_INT}, C_DOUBLE ),
	xIupGetRGBId                      = define_c_proc( iup, "+IupGetRGBId", {C_POINTER,C_POINTER,C_INT,C_POINTER,C_POINTER,C_POINTER} ),
	xIupSetAttributeId2               = define_c_proc( iup, "+IupSetAttributeId2", {C_POINTER,C_POINTER,C_INT,C_INT,C_POINTER} ),
	xIupSetStrAttributeId2            = define_c_proc( iup, "+IupSetStrAttributeId2", {C_POINTER,C_POINTER,C_INT,C_INT,C_POINTER} ),
	xIupSetIntId2                     = define_c_proc( iup, "+IupSetIntId2", {C_POINTER,C_POINTER,C_INT,C_INT,C_INT} ),
	xIupSetFloatId2                   = define_c_proc( iup, "+IupSetFloatId2", {C_POINTER,C_POINTER,C_INT,C_INT,C_FLOAT} ),
	xIupSetDoubleId2                  = define_c_proc( iup, "+IupSetDoubleId2", {C_POINTER,C_POINTER,C_INT,C_INT,C_DOUBLE} ),
	xIupSetRGBId2                     = define_c_proc( iup, "+IupSetRGBId2", {C_POINTER,C_POINTER,C_INT,C_INT,C_UCHAR,C_UCHAR,C_UCHAR} ),
	xIupGetAttributeId2               = define_c_func( iup, "+IupGetAttributeId2", {C_POINTER,C_POINTER,C_INT,C_INT}, C_POINTER ),
	xIupGetIntId2                     = define_c_func( iup, "+IupGetIntId2", {C_POINTER,C_POINTER,C_INT,C_INT}, C_INT ),
	xIupGetFloatId2                   = define_c_func( iup, "+IupGetFloatId2", {C_POINTER,C_POINTER,C_INT,C_INT}, C_FLOAT ),
	xIupGetDoubleId2                  = define_c_func( iup, "+IupGetDoubleId2", {C_POINTER,C_POINTER,C_INT,C_INT}, C_DOUBLE ),
	xIupGetRGBId2                     = define_c_proc( iup, "+IupGetRGBId2", {C_POINTER,C_POINTER,C_INT,C_INT,C_POINTER,C_POINTER,C_POINTER} ),
	xIupSetGlobal                     = define_c_proc( iup, "+IupSetGlobal", {C_POINTER,C_POINTER} ),
	xIupSetStrGlobal                  = define_c_proc( iup, "+IupSetStrGlobal", {C_POINTER,C_POINTER} ),
	xIupGetGlobal                     = define_c_func( iup, "+IupGetGlobal", {C_POINTER}, C_POINTER ),
	xIupSetFocus                      = define_c_func( iup, "+IupSetFocus", {C_POINTER}, C_POINTER ),
	xIupGetFocus                      = define_c_func( iup, "+IupGetFocus", {}, C_POINTER ),
	xIupPreviousField                 = define_c_func( iup, "+IupPreviousField", {C_POINTER}, C_POINTER ),
	xIupNextField                     = define_c_func( iup, "+IupNextField", {C_POINTER}, C_POINTER ),
	xIupGetCallback                   = define_c_func( iup, "+IupGetCallback", {C_POINTER,C_POINTER}, C_POINTER ),
	xIupSetCallback                   = define_c_func( iup, "+IupSetCallback", {C_POINTER,C_POINTER,C_POINTER}, C_POINTER ),
	xIupGetFunction                   = define_c_func( iup, "+IupGetFunction", {C_POINTER}, C_POINTER ),
	xIupSetFunction                   = define_c_func( iup, "+IupSetFunction", {C_POINTER,C_POINTER}, C_POINTER ),
	xIupGetHandle                     = define_c_func( iup, "+IupGetHandle", {C_POINTER}, C_POINTER ),
	xIupSetHandle                     = define_c_func( iup, "+IupSetHandle", {C_POINTER,C_POINTER}, C_POINTER ),
	xIupGetAllNames                   = define_c_func( iup, "+IupGetAllNames", {C_POINTER,C_INT}, C_INT ),
	xIupGetAllDialogs                 = define_c_func( iup, "+IupGetAllDialogs", {C_POINTER,C_INT}, C_INT ),
	xIupGetName                       = define_c_func( iup, "+IupGetName", {C_POINTER}, C_POINTER ),
	xIupSetAttributeHandle            = define_c_proc( iup, "+IupSetAttributeHandle", {C_POINTER,C_POINTER,C_POINTER} ),
	xIupGetAttributeHandle            = define_c_func( iup, "+IupGetAttributeHandle", {C_POINTER,C_POINTER}, C_POINTER ),
	xIupGetClassName                  = define_c_func( iup, "+IupGetClassName", {C_POINTER}, C_POINTER ),
	xIupGetClassType                  = define_c_func( iup, "+IupGetClassType", {C_POINTER}, C_POINTER ),
	xIupGetAllClasses                 = define_c_func( iup, "+IupGetAllClasses", {C_POINTER,C_INT}, C_INT ),
	xIupGetClassAttributes            = define_c_func( iup, "+IupGetClassAttributes", {C_POINTER,C_POINTER,C_INT}, C_INT ),
	xIupGetClassCallbacks             = define_c_func( iup, "+IupGetClassCallbacks", {C_POINTER,C_POINTER,C_INT}, C_INT ),
	xIupSaveClassAttributes           = define_c_proc( iup, "+IupSaveClassAttributes", {C_POINTER} ),
	xIupCopyClassAttributes           = define_c_proc( iup, "+IupCopyClassAttributes", {C_POINTER,C_POINTER} ),
	xIupSetClassDefaultAttribute      = define_c_proc( iup, "+IupSetClassDefaultAttribute", {C_POINTER,C_POINTER,C_POINTER} ),
	xIupClassMatch                    = define_c_func( iup, "+IupClassMatch", {C_POINTER,C_POINTER}, C_INT ),
	xIupCreate                        = define_c_func( iup, "+IupCreatev", {C_POINTER,C_POINTER}, C_POINTER ),
	xIupFill                          = define_c_func( iup, "+IupFill", {}, C_POINTER ),
	xIupRadio                         = define_c_func( iup, "+IupRadio", {C_POINTER}, C_POINTER ),
	xIupVbox                          = define_c_func( iup, "+IupVboxv", {C_POINTER}, C_POINTER ),
	xIupZbox                          = define_c_func( iup, "+IupZboxv", {C_POINTER}, C_POINTER ),
	xIupHbox                          = define_c_func( iup, "+IupHboxv", {C_POINTER}, C_POINTER ),
	xIupNormalizer                    = define_c_func( iup, "+IupNormalizerv", {C_POINTER}, C_POINTER ),
	xIupCbox                          = define_c_func( iup, "+IupCboxv", {C_POINTER}, C_POINTER ),
	xIupSbox                          = define_c_func( iup, "+IupSbox", {C_POINTER}, C_POINTER ),
	xIupSplit                         = define_c_func( iup, "+IupSplit", {C_POINTER,C_POINTER}, C_POINTER ),
	xIupScrollBox                     = define_c_func( iup, "+IupScrollBox", {C_POINTER}, C_POINTER ),
	xIupGridBox                       = define_c_func( iup, "+IupGridBoxv", {C_POINTER}, C_POINTER ),
	xIupExpander                      = define_c_func( iup, "+IupExpander", {C_POINTER}, C_POINTER ),
	xIupDetachBox                     = define_c_func( iup, "+IupDetachBox", {C_POINTER}, C_POINTER ),
	xIupBackgroundBox                 = define_c_func( iup, "+IupBackgroundBox", {C_POINTER}, C_POINTER ),
	xIupFrame                         = define_c_func( iup, "+IupFrame", {C_POINTER}, C_POINTER ),
	xIupImage                         = define_c_func( iup, "+IupImage", {C_INT,C_INT,C_POINTER}, C_POINTER ),
	xIupImageRGB                      = define_c_func( iup, "+IupImageRGB", {C_INT,C_INT,C_POINTER}, C_POINTER ),
	xIupImageRGBA                     = define_c_func( iup, "+IupImageRGBA", {C_INT,C_INT,C_POINTER}, C_POINTER ),
	xIupItem                          = define_c_func( iup, "+IupItem", {C_POINTER,C_POINTER}, C_POINTER ),
	xIupSubmenu                       = define_c_func( iup, "+IupSubmenu", {C_POINTER,C_POINTER}, C_POINTER ),
	xIupSeparator                     = define_c_func( iup, "+IupSeparator", {}, C_POINTER ),
	xIupMenu                          = define_c_func( iup, "+IupMenuv", {C_POINTER}, C_POINTER ),
	xIupButton                        = define_c_func( iup, "+IupButton", {C_POINTER,C_POINTER}, C_POINTER ),
	xIupCanvas                        = define_c_func( iup, "+IupCanvas", {C_POINTER}, C_POINTER ),
	xIupDialog                        = define_c_func( iup, "+IupDialog", {C_POINTER}, C_POINTER ),
	xIupUser                          = define_c_func( iup, "+IupUser", {}, C_POINTER ),
	xIupLabel                         = define_c_func( iup, "+IupLabel", {C_POINTER}, C_POINTER ),
	xIupList                          = define_c_func( iup, "+IupList", {C_POINTER}, C_POINTER ),
	xIupText                          = define_c_func( iup, "+IupText", {C_POINTER}, C_POINTER ),
	xIupMultiLine                     = define_c_func( iup, "+IupMultiLine", {C_POINTER}, C_POINTER ),
	xIupToggle                        = define_c_func( iup, "+IupToggle", {C_POINTER,C_POINTER}, C_POINTER ),
	xIupTimer                         = define_c_func( iup, "+IupTimer", {}, C_POINTER ),
	xIupClipboard                     = define_c_func( iup, "+IupClipboard", {}, C_POINTER ),
	xIupProgressBar                   = define_c_func( iup, "+IupProgressBar", {}, C_POINTER ),
	xIupVal                           = define_c_func( iup, "+IupVal", {C_POINTER}, C_POINTER ),
	xIupTabs                          = define_c_func( iup, "+IupTabsv", {C_POINTER}, C_POINTER ),
	xIupTree                          = define_c_func( iup, "+IupTree", {}, C_POINTER ),
	xIupLink                          = define_c_func( iup, "+IupLink", {C_POINTER,C_POINTER}, C_POINTER ),
	xIupFlatButton                    = define_c_func( iup, "+IupFlatButton", {C_POINTER}, C_POINTER ),
	xIupSpin                          = define_c_func( iup, "+IupSpin", {}, C_POINTER ),
	xIupSpinbox                       = define_c_func( iup, "+IupSpinbox", {C_POINTER}, C_POINTER ),
	xIupSaveImageAsText               = define_c_func( iup, "+IupSaveImageAsText", {C_POINTER,C_POINTER,C_POINTER,C_POINTER}, C_INT ),
	xIupTextConvertLinColToPos        = define_c_proc( iup, "+IupTextConvertLinColToPos", {C_POINTER,C_INT,C_INT,C_POINTER} ),
	xIupTextConvertPosToLinCol        = define_c_proc( iup, "+IupTextConvertPosToLinCol", {C_POINTER,C_INT,C_POINTER,C_POINTER} ),
	xIupConvertXYToPos                = define_c_func( iup, "+IupConvertXYToPos", {C_POINTER,C_INT,C_INT}, C_INT ),
	xIupStoreGlobal                   = define_c_proc( iup, "+IupStoreGlobal", {C_POINTER,C_POINTER} ),
	xIupStoreAttribute                = define_c_proc( iup, "+IupStoreAttribute", {C_POINTER,C_POINTER,C_POINTER} ),
	xIupStoreAttributeId              = define_c_proc( iup, "+IupStoreAttributeId", {C_POINTER,C_POINTER,C_INT,C_POINTER} ),
	xIupStoreAttributeId2             = define_c_proc( iup, "+IupStoreAttributeId2", {C_POINTER,C_POINTER,C_INT,C_INT,C_POINTER} ),
	xIupTreeSetUserId                 = define_c_func( iup, "+IupTreeSetUserId", {C_POINTER,C_INT,C_POINTER}, C_INT ),
	xIupTreeGetUserId                 = define_c_func( iup, "+IupTreeGetUserId", {C_POINTER,C_INT}, C_POINTER ),
	xIupTreeGetId                     = define_c_func( iup, "+IupTreeGetId", {C_POINTER,C_POINTER}, C_INT ),
	xIupTreeSetAttributeHandle        = define_c_proc( iup, "+IupTreeSetAttributeHandle", {C_POINTER,C_POINTER,C_INT,C_POINTER} ),
	xIupTreeSetAttribute              = define_c_proc( iup, "+IupTreeSetAttribute", {C_POINTER,C_POINTER,C_INT,C_POINTER} ),
	xIupTreeStoreAttribute            = define_c_proc( iup, "+IupTreeStoreAttribute", {C_POINTER,C_POINTER,C_INT,C_POINTER} ),
	xIupTreeGetAttribute              = define_c_func( iup, "+IupTreeGetAttribute", {C_POINTER,C_POINTER,C_INT}, C_POINTER ),
	xIupTreeGetInt                    = define_c_func( iup, "+IupTreeGetInt", {C_POINTER,C_POINTER,C_INT}, C_INT ),
	xIupTreeGetFloat                  = define_c_func( iup, "+IupTreeGetFloat", {C_POINTER,C_POINTER,C_INT}, C_FLOAT ),
	xIupGetActionName                 = define_c_func( iup, "+IupGetActionName", {}, C_POINTER ),
	xIupMapFont                       = define_c_func( iup, "+IupMapFont", {C_POINTER}, C_POINTER ),
	xIupUnMapFont                     = define_c_func( iup, "+IupUnMapFont", {C_POINTER}, C_POINTER ),
	xIupFileDlg                       = define_c_func( iup, "+IupFileDlg", {}, C_POINTER ),
	xIupMessageDlg                    = define_c_func( iup, "+IupMessageDlg", {}, C_POINTER ),
	xIupColorDlg                      = define_c_func( iup, "+IupColorDlg", {}, C_POINTER ),
	xIupFontDlg                       = define_c_func( iup, "+IupFontDlg", {}, C_POINTER ),
	xIupProgressDlg                   = define_c_func( iup, "+IupProgressDlg", {}, C_POINTER ),
	xIupGetFile                       = define_c_func( iup, "+IupGetFile", {C_POINTER}, C_INT ),
	xIupMessage                       = define_c_proc( iup, "+IupMessage", {C_POINTER,C_POINTER} ),
	xIupAlarm                         = define_c_func( iup, "+IupAlarm", {C_POINTER,C_POINTER,C_POINTER,C_POINTER,C_POINTER}, C_INT ),
	xIupListDialog                    = define_c_func( iup, "+IupListDialog", {C_INT,C_POINTER,C_INT,C_POINTER,C_INT,C_INT,C_INT,C_POINTER}, C_INT ),
	xIupGetText                       = define_c_func( iup, "+IupGetText", {C_POINTER,C_POINTER}, C_INT ),
	xIupGetColor                      = define_c_func( iup, "+IupGetColor", {C_INT,C_INT,C_POINTER,C_POINTER,C_POINTER}, C_INT ),
	xIupGetParam                      = define_c_func( iup, "+IupGetParamv", {C_POINTER,C_POINTER,C_POINTER,C_POINTER,C_INT,C_INT,C_POINTER}, C_INT ),
	xIupParamf                        = define_c_func( iup, "+IupParamf", {C_POINTER}, C_POINTER ),
	xIupParamBox                      = define_c_func( iup, "+IupParamBox", {C_POINTER,C_POINTER,C_INT}, C_POINTER ),
	xIupLayoutDialog                  = define_c_func( iup, "+IupLayoutDialog", {C_POINTER}, C_POINTER ),
	xIupElementPropertiesDialog       = define_c_func( iup, "+IupElementPropertiesDialog", {C_POINTER}, C_POINTER ),
$

public constant IUP_NAME = "IUP - Portable User Interface"
public constant IUP_DESCRIPTION = "Multi-platform Toolkit for Building Graphical User Interfaces"
public constant IUP_COPYRIGHT = "Copyright (C) 1994-2015 Tecgraf/PUC-Rio"
public constant IUP_VERSION = "3.16" /* bug fixes are reported only by IupVersion functions */
public constant IUP_VERSION_NUMBER = 316000
public constant IUP_VERSION_DATE = "2015/09/15" /* does not include bug fix releases */
/************************************************************************/
/*                        Main API                                      */
/************************************************************************/
--int IupOpen(int *argc, char ***argv);
public function IupOpen(atom argc, sequence argv = {})
	atom p_argv = allocate_string_pointer_array(argv)
	atom result = c_func( xIupOpen, {argc,p_argv} )
	free(p_argv)
	return result
end function

--void IupClose(void);
public procedure IupClose()
	c_proc( xIupClose, {} )
end procedure

--void IupImageLibOpen(void);
public procedure IupImageLibOpen()
	c_proc( xIupImageLibOpen, {} )
end procedure

--int IupMainLoop(void);
public function IupMainLoop()
	atom result = c_func( xIupMainLoop, {} )
	return result
end function

--int IupLoopStep(void);
public function IupLoopStep()
	atom result = c_func( xIupLoopStep, {} )
	return result
end function

--int IupLoopStepWait(void);
public function IupLoopStepWait()
	atom result = c_func( xIupLoopStepWait, {} )
	return result
end function

--int IupMainLoopLevel(void);
public function IupMainLoopLevel()
	atom result = c_func( xIupMainLoopLevel, {} )
	return result
end function

--void IupFlush(void);
public procedure IupFlush()
	c_proc( xIupFlush, {} )
end procedure

--void IupExitLoop(void);
public procedure IupExitLoop()
	c_proc( xIupExitLoop, {} )
end procedure

--int IupRecordInput(const char* filename, int mode);
public function IupRecordInput(object filename = NULL, atom mode)
	if sequence(filename) then filename = allocate_string(filename) end if
	atom result = c_func( xIupRecordInput, {filename,mode} )
	return result
end function

--int IupPlayInput(const char* filename);
public function IupPlayInput(object filename = NULL)
	if sequence(filename) then filename = allocate_string(filename) end if
	atom result = c_func( xIupPlayInput, {filename} )
	return result
end function

--void IupUpdate(Ihandle* ih);
public procedure IupUpdate(atom ih)
	c_proc( xIupUpdate, {ih} )
end procedure

--void IupUpdateChildren(Ihandle* ih);
public procedure IupUpdateChildren(atom ih)
	c_proc( xIupUpdateChildren, {ih} )
end procedure

--void IupRedraw(Ihandle* ih, int children);
public procedure IupRedraw(atom ih, atom children)
	c_proc( xIupRedraw, {ih,children} )
end procedure

--void IupRefresh(Ihandle* ih);
public procedure IupRefresh(atom ih)
	c_proc( xIupRefresh, {ih} )
end procedure

--void IupRefreshChildren(Ihandle* ih);
public procedure IupRefreshChildren(atom ih)
	c_proc( xIupRefreshChildren, {ih} )
end procedure

--int IupHelp(const char* url);
public function IupHelp(object url = NULL)
	if sequence(url) then url = allocate_string(url) end if
	atom result = c_func( xIupHelp, {url} )
	return result
end function

--char* IupLoad(const char *filename);
public function IupLoad(object filename = NULL)
	if sequence(filename) then filename = allocate_string(filename) end if
	atom ptr = c_func( xIupLoad, {filename} )
	sequence str = ""
	if ptr != NULL then str = peek_string( ptr ) end if
	return str
end function

--char* IupLoadBuffer(const char *buffer);
public function IupLoadBuffer(object buffer = NULL)
	if sequence(buffer) then buffer = allocate_string(buffer) end if
	atom ptr = c_func( xIupLoadBuffer, {buffer} )
	sequence str = ""
	if ptr != NULL then str = peek_string( ptr ) end if
	return str
end function

--char* IupVersion(void);
public function IupVersion()
	atom ptr = c_func( xIupVersion, {} )
	sequence str = ""
	if ptr != NULL then str = peek_string( ptr ) end if
	return str
end function

--char* IupVersionDate(void);
public function IupVersionDate()
	atom ptr = c_func( xIupVersionDate, {} )
	sequence str = ""
	if ptr != NULL then str = peek_string( ptr ) end if
	return str
end function

--int IupVersionNumber(void);
public function IupVersionNumber()
	atom result = c_func( xIupVersionNumber, {} )
	return result
end function

--void IupSetLanguage(const char *lng);
public procedure IupSetLanguage(object lng = NULL)
	if sequence(lng) then lng = allocate_string(lng) end if
	c_proc( xIupSetLanguage, {lng} )
end procedure

--char* IupGetLanguage(void);
public function IupGetLanguage()
	atom ptr = c_func( xIupGetLanguage, {} )
	sequence str = ""
	if ptr != NULL then str = peek_string( ptr ) end if
	return str
end function

--void IupSetLanguageString(const char* name, const char* str);
public procedure IupSetLanguageString(object name = NULL, object str = NULL)
	if sequence(name) then name = allocate_string(name) end if
	if sequence(str) then str = allocate_string(str) end if
	c_proc( xIupSetLanguageString, {name,str} )
end procedure

--void IupStoreLanguageString(const char* name, const char* str);
public procedure IupStoreLanguageString(object name = NULL, object str = NULL)
	if sequence(name) then name = allocate_string(name) end if
	if sequence(str) then str = allocate_string(str) end if
	c_proc( xIupStoreLanguageString, {name,str} )
end procedure

--char* IupGetLanguageString(const char* name);
public function IupGetLanguageString(object name = NULL)
	if sequence(name) then name = allocate_string(name) end if
	atom ptr = c_func( xIupGetLanguageString, {name} )
	sequence str = ""
	if ptr != NULL then str = peek_string( ptr ) end if
	return str
end function

--void IupSetLanguagePack(Ihandle* ih);
public procedure IupSetLanguagePack(atom ih)
	c_proc( xIupSetLanguagePack, {ih} )
end procedure

--void IupDestroy(Ihandle* ih);
public procedure IupDestroy(atom ih)
	c_proc( xIupDestroy, {ih} )
end procedure

--void IupDetach(Ihandle* child);
public procedure IupDetach(atom child)
	c_proc( xIupDetach, {child} )
end procedure

--Ihandle* IupAppend(Ihandle* ih, Ihandle* child);
public function IupAppend(atom ih, atom child)
	atom result = c_func( xIupAppend, {ih,child} )
	return result
end function

--Ihandle* IupInsert(Ihandle* ih, Ihandle* ref_child, Ihandle* child);
public function IupInsert(atom ih, atom ref_child, atom child)
	atom result = c_func( xIupInsert, {ih,ref_child,child} )
	return result
end function

--Ihandle* IupGetChild(Ihandle* ih, int pos);
public function IupGetChild(atom ih, atom pos)
	atom result = c_func( xIupGetChild, {ih,pos} )
	return result
end function

--int IupGetChildPos(Ihandle* ih, Ihandle* child);
public function IupGetChildPos(atom ih, atom child)
	atom result = c_func( xIupGetChildPos, {ih,child} )
	return result
end function

--int IupGetChildCount(Ihandle* ih);
public function IupGetChildCount(atom ih)
	atom result = c_func( xIupGetChildCount, {ih} )
	return result
end function

--Ihandle* IupGetNextChild(Ihandle* ih, Ihandle* child);
public function IupGetNextChild(atom ih, atom child)
	atom result = c_func( xIupGetNextChild, {ih,child} )
	return result
end function

--Ihandle* IupGetBrother(Ihandle* ih);
public function IupGetBrother(atom ih)
	atom result = c_func( xIupGetBrother, {ih} )
	return result
end function

--Ihandle* IupGetParent(Ihandle* ih);
public function IupGetParent(atom ih)
	atom result = c_func( xIupGetParent, {ih} )
	return result
end function

--Ihandle* IupGetDialog(Ihandle* ih);
public function IupGetDialog(atom ih)
	atom result = c_func( xIupGetDialog, {ih} )
	return result
end function

--Ihandle* IupGetDialogChild(Ihandle* ih, const char* name);
public function IupGetDialogChild(atom ih, object name = NULL)
	if sequence(name) then name = allocate_string(name) end if
	atom result = c_func( xIupGetDialogChild, {ih,name} )
	return result
end function

--int IupReparent(Ihandle* ih, Ihandle* new_parent, Ihandle* ref_child);
public function IupReparent(atom ih, atom new_parent, atom ref_child)
	atom result = c_func( xIupReparent, {ih,new_parent,ref_child} )
	return result
end function

--int IupPopup(Ihandle* ih, int x, int y);
public function IupPopup(atom ih, atom x, atom y)
	atom result = c_func( xIupPopup, {ih,x,y} )
	return result
end function

--int IupShow(Ihandle* ih);
public function IupShow(atom ih)
	atom result = c_func( xIupShow, {ih} )
	return result
end function

--int IupShowXY(Ihandle* ih, int x, int y);
public function IupShowXY(atom ih, atom x, atom y)
	atom result = c_func( xIupShowXY, {ih,x,y} )
	return result
end function

--int IupHide(Ihandle* ih);
public function IupHide(atom ih)
	atom result = c_func( xIupHide, {ih} )
	return result
end function

--int IupMap(Ihandle* ih);
public function IupMap(atom ih)
	atom result = c_func( xIupMap, {ih} )
	return result
end function

--void IupUnmap(Ihandle *ih);
public procedure IupUnmap(atom ih)
	c_proc( xIupUnmap, {ih} )
end procedure

--void IupResetAttribute(Ihandle *ih, const char* name);
public procedure IupResetAttribute(atom ih, object name = NULL)
	if sequence(name) then name = allocate_string(name) end if
	c_proc( xIupResetAttribute, {ih,name} )
end procedure

--int IupGetAllAttributes(Ihandle* ih, char** names, int n);
public function IupGetAllAttributes(atom ih)
	atom n = c_func( xIupGetAllAttributes, {ih,NULL,0} )
	atom ptr = allocate_data( sizeof(C_POINTER) * n, 1 )
	n = c_func( xIupGetAllAttributes, {ih,ptr,n} )
	return peek_string_pointer_array( ptr, n )
end function

--Ihandle* IupSetAttributes(Ihandle* ih, const char *str);
public function IupSetAttributes(atom ih, object str = NULL)
	if sequence(str) then str = allocate_string(str) end if
	atom result = c_func( xIupSetAttributes, {ih,str} )
	return result
end function

--char* IupGetAttributes(Ihandle* ih);
public function IupGetAttributes(atom ih)
	atom ptr = c_func( xIupGetAttributes, {ih} )
	sequence str = ""
	if ptr != NULL then str = peek_string( ptr ) end if
	return str
end function

--void IupSetAttribute(Ihandle* ih, const char* name, const char* value);
public procedure IupSetAttribute(atom ih, object name = NULL, object value = NULL)
	if sequence(name) then name = allocate_string(name) end if
	if sequence(value) then value = allocate_string(value) end if
	c_proc( xIupSetAttribute, {ih,name,value} )
end procedure

--void IupSetStrAttribute(Ihandle* ih, const char* name, const char* value);
public procedure IupSetStrAttribute(atom ih, object name = NULL, object value = NULL)
	if sequence(name) then name = allocate_string(name) end if
	if sequence(value) then value = allocate_string(value) end if
	c_proc( xIupSetStrAttribute, {ih,name,value} )
end procedure

--void IupSetInt(Ihandle* ih, const char* name, int value);
public procedure IupSetInt(atom ih, object name = NULL, atom value)
	if sequence(name) then name = allocate_string(name) end if
	c_proc( xIupSetInt, {ih,name,value} )
end procedure

--void IupSetFloat(Ihandle* ih, const char* name, float value);
public procedure IupSetFloat(atom ih, object name = NULL, atom value)
	if sequence(name) then name = allocate_string(name) end if
	c_proc( xIupSetFloat, {ih,name,value} )
end procedure

--void IupSetDouble(Ihandle* ih, const char* name, double value);
public procedure IupSetDouble(atom ih, object name = NULL, atom value)
	if sequence(name) then name = allocate_string(name) end if
	c_proc( xIupSetDouble, {ih,name,value} )
end procedure

--void IupSetRGB(Ihandle *ih, const char* name, unsigned char r, unsigned char g, unsigned char b);
public procedure IupSetRGB(atom ih, object name = NULL, atom r, atom g, atom b)
	if sequence(name) then name = allocate_string(name) end if
	c_proc( xIupSetRGB, {ih,name,r,g,b} )
end procedure

--char* IupGetAttribute(Ihandle* ih, const char* name);
public function IupGetAttribute(atom ih, object name = NULL)
	if sequence(name) then name = allocate_string(name) end if
	atom ptr = c_func( xIupGetAttribute, {ih,name} )
	sequence str = ""
	if ptr != NULL then str = peek_string( ptr ) end if
	return str
end function

--int IupGetInt(Ihandle* ih, const char* name);
public function IupGetInt(atom ih, object name = NULL)
	if sequence(name) then name = allocate_string(name) end if
	atom result = c_func( xIupGetInt, {ih,name} )
	return result
end function

--int IupGetInt2(Ihandle* ih, const char* name);
public function IupGetInt2(atom ih, object name = NULL)
	if sequence(name) then name = allocate_string(name) end if
	atom result = c_func( xIupGetInt2, {ih,name} )
	return result
end function

--int IupGetIntInt(Ihandle *ih, const char* name, int *i1, int *i2);
public function IupGetIntInt(atom ih, object name = NULL, atom i1, atom i2)
	if sequence(name) then name = allocate_string(name) end if
	atom result = c_func( xIupGetIntInt, {ih,name,i1,i2} )
	return result
end function

--float IupGetFloat(Ihandle* ih, const char* name);
public function IupGetFloat(atom ih, object name = NULL)
	if sequence(name) then name = allocate_string(name) end if
	atom result = c_func( xIupGetFloat, {ih,name} )
	return result
end function

--double IupGetDouble(Ihandle* ih, const char* name);
public function IupGetDouble(atom ih, object name = NULL)
	if sequence(name) then name = allocate_string(name) end if
	atom result = c_func( xIupGetDouble, {ih,name} )
	return result
end function

--void IupGetRGB(Ihandle *ih, const char* name, unsigned char *r, unsigned char *g, unsigned char *b);
public function IupGetRGB(atom ih, object name = NULL)
	atom rgb = allocate_data( sizeof(C_INT) * 3, 1 )
	atom r = rgb + sizeof(C_INT) * 0
	atom g = rgb + sizeof(C_INT) * 1
	atom b = rgb + sizeof(C_INT) * 2
	c_proc( xIupGetRGB, {ih,name,r,g,b} )
	return peek({ rgb, 3 })
end function

--void IupSetAttributeId(Ihandle *ih, const char* name, int id, const char *value);
public procedure IupSetAttributeId(atom ih, object name = NULL, atom id, object value = NULL)
	if sequence(name) then name = allocate_string(name) end if
	if sequence(value) then value = allocate_string(value) end if
	c_proc( xIupSetAttributeId, {ih,name,id,value} )
end procedure

--void IupSetStrAttributeId(Ihandle *ih, const char* name, int id, const char *value);
public procedure IupSetStrAttributeId(atom ih, object name = NULL, atom id, object value = NULL)
	if sequence(name) then name = allocate_string(name) end if
	if sequence(value) then value = allocate_string(value) end if
	c_proc( xIupSetStrAttributeId, {ih,name,id,value} )
end procedure

--void IupSetIntId(Ihandle* ih, const char* name, int id, int value);
public procedure IupSetIntId(atom ih, object name = NULL, atom id, atom value)
	if sequence(name) then name = allocate_string(name) end if
	c_proc( xIupSetIntId, {ih,name,id,value} )
end procedure

--void IupSetFloatId(Ihandle* ih, const char* name, int id, float value);
public procedure IupSetFloatId(atom ih, object name = NULL, atom id, atom value)
	if sequence(name) then name = allocate_string(name) end if
	c_proc( xIupSetFloatId, {ih,name,id,value} )
end procedure

--void IupSetDoubleId(Ihandle* ih, const char* name, int id, double value);
public procedure IupSetDoubleId(atom ih, object name = NULL, atom id, atom value)
	if sequence(name) then name = allocate_string(name) end if
	c_proc( xIupSetDoubleId, {ih,name,id,value} )
end procedure

--void IupSetRGBId(Ihandle *ih, const char* name, int id, unsigned char r, unsigned char g, unsigned char b);
public procedure IupSetRGBId(atom ih, object name = NULL, atom id, atom r, atom g, atom b)
	if sequence(name) then name = allocate_string(name) end if
	c_proc( xIupSetRGBId, {ih,name,id,r,g,b} )
end procedure

--char* IupGetAttributeId(Ihandle *ih, const char* name, int id);
public function IupGetAttributeId(atom ih, object name = NULL, atom id)
	if sequence(name) then name = allocate_string(name) end if
	atom ptr = c_func( xIupGetAttributeId, {ih,name,id} )
	sequence str = ""
	if ptr != NULL then str = peek_string( ptr ) end if
	return str
end function

--int IupGetIntId(Ihandle *ih, const char* name, int id);
public function IupGetIntId(atom ih, object name = NULL, atom id)
	if sequence(name) then name = allocate_string(name) end if
	atom result = c_func( xIupGetIntId, {ih,name,id} )
	return result
end function

--float IupGetFloatId(Ihandle *ih, const char* name, int id);
public function IupGetFloatId(atom ih, object name = NULL, atom id)
	if sequence(name) then name = allocate_string(name) end if
	atom result = c_func( xIupGetFloatId, {ih,name,id} )
	return result
end function

--double IupGetDoubleId(Ihandle *ih, const char* name, int id);
public function IupGetDoubleId(atom ih, object name = NULL, atom id)
	if sequence(name) then name = allocate_string(name) end if
	atom result = c_func( xIupGetDoubleId, {ih,name,id} )
	return result
end function

--void IupGetRGBId(Ihandle *ih, const char* name, int id, unsigned char *r, unsigned char *g, unsigned char *b);
public function IupGetRGBId(atom ih, object name = NULL, atom id)
	atom rgb = allocate_data( sizeof(C_INT) * 3, 1 )
	atom r = rgb + sizeof(C_INT) * 0
	atom g = rgb + sizeof(C_INT) * 1
	atom b = rgb + sizeof(C_INT) * 2
	c_proc( xIupGetRGBId, {ih,name,id,r,g,b} )
	return peek({ rgb, 3 })
end function

--void IupSetAttributeId2(Ihandle* ih, const char* name, int lin, int col, const char* value);
public procedure IupSetAttributeId2(atom ih, object name = NULL, atom lin, atom col, object value = NULL)
	if sequence(name) then name = allocate_string(name) end if
	if sequence(value) then value = allocate_string(value) end if
	c_proc( xIupSetAttributeId2, {ih,name,lin,col,value} )
end procedure

--void IupSetStrAttributeId2(Ihandle* ih, const char* name, int lin, int col, const char* value);
public procedure IupSetStrAttributeId2(atom ih, object name = NULL, atom lin, atom col, object value = NULL)
	if sequence(name) then name = allocate_string(name) end if
	if sequence(value) then value = allocate_string(value) end if
	c_proc( xIupSetStrAttributeId2, {ih,name,lin,col,value} )
end procedure

--void IupSetIntId2(Ihandle* ih, const char* name, int lin, int col, int value);
public procedure IupSetIntId2(atom ih, object name = NULL, atom lin, atom col, atom value)
	if sequence(name) then name = allocate_string(name) end if
	c_proc( xIupSetIntId2, {ih,name,lin,col,value} )
end procedure

--void IupSetFloatId2(Ihandle* ih, const char* name, int lin, int col, float value);
public procedure IupSetFloatId2(atom ih, object name = NULL, atom lin, atom col, atom value)
	if sequence(name) then name = allocate_string(name) end if
	c_proc( xIupSetFloatId2, {ih,name,lin,col,value} )
end procedure

--void IupSetDoubleId2(Ihandle* ih, const char* name, int lin, int col, double value);
public procedure IupSetDoubleId2(atom ih, object name = NULL, atom lin, atom col, atom value)
	if sequence(name) then name = allocate_string(name) end if
	c_proc( xIupSetDoubleId2, {ih,name,lin,col,value} )
end procedure

--void IupSetRGBId2(Ihandle *ih, const char* name, int lin, int col, unsigned char r, unsigned char g, unsigned char b);
public procedure IupSetRGBId2(atom ih, object name = NULL, atom lin, atom col, atom r, atom g, atom b)
	if sequence(name) then name = allocate_string(name) end if
	c_proc( xIupSetRGBId2, {ih,name,lin,col,r,g,b} )
end procedure

--char* IupGetAttributeId2(Ihandle* ih, const char* name, int lin, int col);
public function IupGetAttributeId2(atom ih, object name = NULL, atom lin, atom col)
	if sequence(name) then name = allocate_string(name) end if
	atom ptr = c_func( xIupGetAttributeId2, {ih,name,lin,col} )
	sequence str = ""
	if ptr != NULL then str = peek_string( ptr ) end if
	return str
end function

--int IupGetIntId2(Ihandle* ih, const char* name, int lin, int col);
public function IupGetIntId2(atom ih, object name = NULL, atom lin, atom col)
	if sequence(name) then name = allocate_string(name) end if
	atom result = c_func( xIupGetIntId2, {ih,name,lin,col} )
	return result
end function

--float IupGetFloatId2(Ihandle* ih, const char* name, int lin, int col);
public function IupGetFloatId2(atom ih, object name = NULL, atom lin, atom col)
	if sequence(name) then name = allocate_string(name) end if
	atom result = c_func( xIupGetFloatId2, {ih,name,lin,col} )
	return result
end function

--double IupGetDoubleId2(Ihandle* ih, const char* name, int lin, int col);
public function IupGetDoubleId2(atom ih, object name = NULL, atom lin, atom col)
	if sequence(name) then name = allocate_string(name) end if
	atom result = c_func( xIupGetDoubleId2, {ih,name,lin,col} )
	return result
end function

--void IupGetRGBId2(Ihandle *ih, const char* name, int lin, int col, unsigned char *r, unsigned char *g, unsigned char *b);
public function IupGetRGBId2(atom ih, object name = NULL, atom lin, atom col)
	atom rgb = allocate_data( sizeof(C_INT) * 3, 1 )
	atom r = rgb + sizeof(C_INT) * 0
	atom g = rgb + sizeof(C_INT) * 1
	atom b = rgb + sizeof(C_INT) * 2
	c_proc( xIupGetRGBId2, {ih,name,lin,col,r,g,b} )
	return peek({ rgb, 3 })
end function

--void IupSetGlobal(const char* name, const char* value);
public procedure IupSetGlobal(object name = NULL, object value = NULL)
	if sequence(name) then name = allocate_string(name) end if
	if sequence(value) then value = allocate_string(value) end if
	c_proc( xIupSetGlobal, {name,value} )
end procedure

--void IupSetStrGlobal(const char* name, const char* value);
public procedure IupSetStrGlobal(object name = NULL, object value = NULL)
	if sequence(name) then name = allocate_string(name) end if
	if sequence(value) then value = allocate_string(value) end if
	c_proc( xIupSetStrGlobal, {name,value} )
end procedure

--char* IupGetGlobal(const char* name);
public function IupGetGlobal(object name = NULL)
	if sequence(name) then name = allocate_string(name) end if
	atom ptr = c_func( xIupGetGlobal, {name} )
	sequence str = ""
	if ptr != NULL then str = peek_string( ptr ) end if
	return str
end function

--Ihandle* IupSetFocus(Ihandle* ih);
public function IupSetFocus(atom ih)
	atom result = c_func( xIupSetFocus, {ih} )
	return result
end function

--Ihandle* IupGetFocus(void);
public function IupGetFocus()
	atom result = c_func( xIupGetFocus, {} )
	return result
end function

--Ihandle* IupPreviousField(Ihandle* ih);
public function IupPreviousField(atom ih)
	atom result = c_func( xIupPreviousField, {ih} )
	return result
end function

--Ihandle* IupNextField(Ihandle* ih);
public function IupNextField(atom ih)
	atom result = c_func( xIupNextField, {ih} )
	return result
end function

--Icallback IupGetCallback(Ihandle* ih, const char *name);
public function IupGetCallback(atom ih, object name = NULL)
	if sequence(name) then name = allocate_string(name) end if
	atom result = c_func( xIupGetCallback, {ih,name} )
	return result
end function

--Icallback IupSetCallback(Ihandle* ih, const char *name, Icallback func);
public function IupSetCallback(atom ih, object name = NULL, atom func)
	if sequence(name) then name = allocate_string(name) end if
	atom result = c_func( xIupSetCallback, {ih,name,func} )
	return result
end function

--Icallback IupGetFunction(const char *name);
public function IupGetFunction(object name = NULL)
	if sequence(name) then name = allocate_string(name) end if
	atom result = c_func( xIupGetFunction, {name} )
	return result
end function

--Icallback IupSetFunction(const char *name, Icallback func);
public function IupSetFunction(object name = NULL, atom func)
	if sequence(name) then name = allocate_string(name) end if
	atom result = c_func( xIupSetFunction, {name,func} )
	return result
end function

--Ihandle* IupGetHandle(const char *name);
public function IupGetHandle(object name = NULL)
	if sequence(name) then name = allocate_string(name) end if
	atom result = c_func( xIupGetHandle, {name} )
	return result
end function

--Ihandle* IupSetHandle(const char *name, Ihandle* ih);
public function IupSetHandle(object name = NULL, atom ih)
	if sequence(name) then name = allocate_string(name) end if
	atom result = c_func( xIupSetHandle, {name,ih} )
	return result
end function

--int IupGetAllNames(char** names, int n);
public function IupGetAllNames()
	atom n = c_func( xIupGetAllNames, {NULL,0} )
	atom ptr = allocate_data( sizeof(C_POINTER) * n, 1 )
	n = c_func( xIupGetAllNames, {ptr,n} )
	return peek_string_pointer_array( ptr, n )
end function

--int IupGetAllDialogs(char** names, int n);
public function IupGetAllDialogs()
	atom n = c_func( xIupGetAllDialogs, {NULL,0} )
	atom ptr = allocate_data( sizeof(C_POINTER) * n, 1 )
	n = c_func( xIupGetAllDialogs, {ptr,n} )
	return peek_string_pointer_array( ptr, n )
end function

--char* IupGetName(Ihandle* ih);
public function IupGetName(atom ih)
	atom ptr = c_func( xIupGetName, {ih} )
	sequence str = ""
	if ptr != NULL then str = peek_string( ptr ) end if
	return str
end function

--void IupSetAttributeHandle(Ihandle* ih, const char* name, Ihandle* ih_named);
public procedure IupSetAttributeHandle(atom ih, object name = NULL, atom ih_named)
	if sequence(name) then name = allocate_string(name) end if
	c_proc( xIupSetAttributeHandle, {ih,name,ih_named} )
end procedure

--Ihandle* IupGetAttributeHandle(Ihandle* ih, const char* name);
public function IupGetAttributeHandle(atom ih, object name = NULL)
	if sequence(name) then name = allocate_string(name) end if
	atom result = c_func( xIupGetAttributeHandle, {ih,name} )
	return result
end function

--char* IupGetClassName(Ihandle* ih);
public function IupGetClassName(atom ih)
	atom ptr = c_func( xIupGetClassName, {ih} )
	sequence str = ""
	if ptr != NULL then str = peek_string( ptr ) end if
	return str
end function

--char* IupGetClassType(Ihandle* ih);
public function IupGetClassType(atom ih)
	atom ptr = c_func( xIupGetClassType, {ih} )
	sequence str = ""
	if ptr != NULL then str = peek_string( ptr ) end if
	return str
end function

--int IupGetAllClasses(char** names, int n);
public function IupGetAllClasses()
	atom n = c_func( xIupGetAllClasses, {NULL,0} )
	atom ptr = allocate_data( sizeof(C_POINTER) * n, 1 )
	n = c_func( xIupGetAllClasses, {ptr,n} )
	return peek_string_pointer_array( ptr, n )
end function

--int IupGetClassAttributes(const char* classname, char** names, int n);
public function IupGetClassAttributes(object classname = NULL)
	atom n = c_func( xIupGetClassAttributes, {classname,NULL,0} )
	atom ptr = allocate_data( sizeof(C_POINTER) * n, 1 )
	n = c_func( xIupGetClassAttributes, {classname,ptr,n} )
	return peek_string_pointer_array( ptr, n )
end function

--int IupGetClassCallbacks(const char* classname, char** names, int n);
public function IupGetClassCallbacks(object classname = NULL)
	atom n = c_func( xIupGetClassCallbacks, {classname,NULL,0} )
	atom ptr = allocate_data( sizeof(C_POINTER) * n, 1 )
	n = c_func( xIupGetClassCallbacks, {classname,ptr,n} )
	return peek_string_pointer_array( ptr, n )
end function

--void IupSaveClassAttributes(Ihandle* ih);
public procedure IupSaveClassAttributes(atom ih)
	c_proc( xIupSaveClassAttributes, {ih} )
end procedure

--void IupCopyClassAttributes(Ihandle* src_ih, Ihandle* dst_ih);
public procedure IupCopyClassAttributes(atom src_ih, atom dst_ih)
	c_proc( xIupCopyClassAttributes, {src_ih,dst_ih} )
end procedure

--void IupSetClassDefaultAttribute(const char* classname, const char *name, const char* value);
public procedure IupSetClassDefaultAttribute(object classname = NULL, object name = NULL, object value = NULL)
	if sequence(classname) then classname = allocate_string(classname) end if
	if sequence(name) then name = allocate_string(name) end if
	if sequence(value) then value = allocate_string(value) end if
	c_proc( xIupSetClassDefaultAttribute, {classname,name,value} )
end procedure

--int IupClassMatch(Ihandle* ih, const char* classname);
public function IupClassMatch(atom ih, object classname = NULL)
	if sequence(classname) then classname = allocate_string(classname) end if
	atom result = c_func( xIupClassMatch, {ih,classname} )
	return result
end function

--Ihandle* IupCreatev(const char *classname, void* *params);
public function IupCreate(object classname = NULL, sequence params = {})
	if sequence(classname) then classname = allocate_string(classname) end if
	atom p_params = allocate_pointer_array(params)
	atom result = c_func( xIupCreate, {classname,p_params} )
	free(p_params)
	return result
end function

/************************************************************************/
/*                        Elements                                      */
/************************************************************************/
--Ihandle* IupFill(void);
public function IupFill()
	atom result = c_func( xIupFill, {} )
	return result
end function

--Ihandle* IupRadio(Ihandle* child);
public function IupRadio(atom child)
	atom result = c_func( xIupRadio, {child} )
	return result
end function

--Ihandle* IupVboxv(Ihandle* *children);
public function IupVbox(sequence children = {})
	atom p_children = allocate_pointer_array(children)
	atom result = c_func( xIupVbox, {p_children} )
	free(p_children)
	return result
end function

--Ihandle* IupZboxv(Ihandle* *children);
public function IupZbox(sequence children = {})
	atom p_children = allocate_pointer_array(children)
	atom result = c_func( xIupZbox, {p_children} )
	free(p_children)
	return result
end function

--Ihandle* IupHboxv(Ihandle* *children);
public function IupHbox(sequence children = {})
	atom p_children = allocate_pointer_array(children)
	atom result = c_func( xIupHbox, {p_children} )
	free(p_children)
	return result
end function

--Ihandle* IupNormalizerv(Ihandle* *ih_list);
public function IupNormalizer(sequence ih_list = {})
	atom p_ih_list = allocate_pointer_array(ih_list)
	atom result = c_func( xIupNormalizer, {p_ih_list} )
	free(p_ih_list)
	return result
end function

--Ihandle* IupCboxv(Ihandle* *children);
public function IupCbox(sequence children = {})
	atom p_children = allocate_pointer_array(children)
	atom result = c_func( xIupCbox, {p_children} )
	free(p_children)
	return result
end function

--Ihandle* IupSbox(Ihandle *child);
public function IupSbox(atom child)
	atom result = c_func( xIupSbox, {child} )
	return result
end function

--Ihandle* IupSplit(Ihandle* child1, Ihandle* child2);
public function IupSplit(atom child1, atom child2)
	atom result = c_func( xIupSplit, {child1,child2} )
	return result
end function

--Ihandle* IupScrollBox(Ihandle* child);
public function IupScrollBox(atom child)
	atom result = c_func( xIupScrollBox, {child} )
	return result
end function

--Ihandle* IupGridBoxv(Ihandle **children);
public function IupGridBox(sequence children = {})
	atom p_children = allocate_pointer_array(children)
	atom result = c_func( xIupGridBox, {p_children} )
	free(p_children)
	return result
end function

--Ihandle* IupExpander(Ihandle *child);
public function IupExpander(atom child)
	atom result = c_func( xIupExpander, {child} )
	return result
end function

--Ihandle* IupDetachBox(Ihandle *child);
public function IupDetachBox(atom child)
	atom result = c_func( xIupDetachBox, {child} )
	return result
end function

--Ihandle* IupBackgroundBox(Ihandle *child);
public function IupBackgroundBox(atom child)
	atom result = c_func( xIupBackgroundBox, {child} )
	return result
end function

--Ihandle* IupFrame(Ihandle* child);
public function IupFrame(atom child)
	atom result = c_func( xIupFrame, {child} )
	return result
end function

--Ihandle* IupImage(int width, int height, const unsigned char *pixmap);
public function IupImage(atom width, atom height, atom pixmap)
	atom result = c_func( xIupImage, {width,height,pixmap} )
	return result
end function

--Ihandle* IupImageRGB(int width, int height, const unsigned char *pixmap);
public function IupImageRGB(atom width, atom height, atom pixmap)
	atom result = c_func( xIupImageRGB, {width,height,pixmap} )
	return result
end function

--Ihandle* IupImageRGBA(int width, int height, const unsigned char *pixmap);
public function IupImageRGBA(atom width, atom height, atom pixmap)
	atom result = c_func( xIupImageRGBA, {width,height,pixmap} )
	return result
end function

--Ihandle* IupItem(const char* title, const char* action);
public function IupItem(object title = NULL, object action = NULL)
	if sequence(title) then title = allocate_string(title) end if
	if sequence(action) then action = allocate_string(action) end if
	atom result = c_func( xIupItem, {title,action} )
	return result
end function

--Ihandle* IupSubmenu(const char* title, Ihandle* child);
public function IupSubmenu(object title = NULL, atom child)
	if sequence(title) then title = allocate_string(title) end if
	atom result = c_func( xIupSubmenu, {title,child} )
	return result
end function

--Ihandle* IupSeparator(void);
public function IupSeparator()
	atom result = c_func( xIupSeparator, {} )
	return result
end function

--Ihandle* IupMenuv(Ihandle* *children);
public function IupMenu(sequence children = {})
	atom p_children = allocate_pointer_array(children)
	atom result = c_func( xIupMenu, {p_children} )
	free(p_children)
	return result
end function

--Ihandle* IupButton(const char* title, const char* action);
public function IupButton(object title = NULL, object action = NULL)
	if sequence(title) then title = allocate_string(title) end if
	if sequence(action) then action = allocate_string(action) end if
	atom result = c_func( xIupButton, {title,action} )
	return result
end function

--Ihandle* IupCanvas(const char* action);
public function IupCanvas(object action = NULL)
	if sequence(action) then action = allocate_string(action) end if
	atom result = c_func( xIupCanvas, {action} )
	return result
end function

--Ihandle* IupDialog(Ihandle* child);
public function IupDialog(atom child)
	atom result = c_func( xIupDialog, {child} )
	return result
end function

--Ihandle* IupUser(void);
public function IupUser()
	atom result = c_func( xIupUser, {} )
	return result
end function

--Ihandle* IupLabel(const char* title);
public function IupLabel(object title = NULL)
	if sequence(title) then title = allocate_string(title) end if
	atom result = c_func( xIupLabel, {title} )
	return result
end function

--Ihandle* IupList(const char* action);
public function IupList(object action = NULL)
	if sequence(action) then action = allocate_string(action) end if
	atom result = c_func( xIupList, {action} )
	return result
end function

--Ihandle* IupText(const char* action);
public function IupText(object action = NULL)
	if sequence(action) then action = allocate_string(action) end if
	atom result = c_func( xIupText, {action} )
	return result
end function

--Ihandle* IupMultiLine(const char* action);
public function IupMultiLine(object action = NULL)
	if sequence(action) then action = allocate_string(action) end if
	atom result = c_func( xIupMultiLine, {action} )
	return result
end function

--Ihandle* IupToggle(const char* title, const char* action);
public function IupToggle(object title = NULL, object action = NULL)
	if sequence(title) then title = allocate_string(title) end if
	if sequence(action) then action = allocate_string(action) end if
	atom result = c_func( xIupToggle, {title,action} )
	return result
end function

--Ihandle* IupTimer(void);
public function IupTimer()
	atom result = c_func( xIupTimer, {} )
	return result
end function

--Ihandle* IupClipboard(void);
public function IupClipboard()
	atom result = c_func( xIupClipboard, {} )
	return result
end function

--Ihandle* IupProgressBar(void);
public function IupProgressBar()
	atom result = c_func( xIupProgressBar, {} )
	return result
end function

--Ihandle* IupVal(const char *type);
public function IupVal(object _type = NULL)
	if sequence(_type) then _type = allocate_string(_type) end if
	atom result = c_func( xIupVal, {_type} )
	return result
end function

--Ihandle* IupTabsv(Ihandle* *children);
public function IupTabs(sequence children = {})
	atom p_children = allocate_pointer_array(children)
	atom result = c_func( xIupTabs, {p_children} )
	free(p_children)
	return result
end function

--Ihandle* IupTree(void);
public function IupTree()
	atom result = c_func( xIupTree, {} )
	return result
end function

--Ihandle* IupLink(const char* url, const char* title);
public function IupLink(object url = NULL, object title = NULL)
	if sequence(url) then url = allocate_string(url) end if
	if sequence(title) then title = allocate_string(title) end if
	atom result = c_func( xIupLink, {url,title} )
	return result
end function

--Ihandle* IupFlatButton(const char* title);
public function IupFlatButton(object title = NULL)
	if sequence(title) then title = allocate_string(title) end if
	atom result = c_func( xIupFlatButton, {title} )
	return result
end function

/* Old controls, use SPIN attribute of IupText */
--Ihandle* IupSpin(void);
public function IupSpin()
	atom result = c_func( xIupSpin, {} )
	return result
end function

--Ihandle* IupSpinbox(Ihandle* child);
public function IupSpinbox(atom child)
	atom result = c_func( xIupSpinbox, {child} )
	return result
end function

/************************************************************************/
/*                      Utilities                                       */
/************************************************************************/
/* IupImage utility */
--int IupSaveImageAsText(Ihandle* ih, const char* file_name, const char* format, const char* name);
public function IupSaveImageAsText(atom ih, object file_name = NULL, object format = NULL, object name = NULL)
	if sequence(file_name) then file_name = allocate_string(file_name) end if
	if sequence(format) then format = allocate_string(format) end if
	if sequence(name) then name = allocate_string(name) end if
	atom result = c_func( xIupSaveImageAsText, {ih,file_name,format,name} )
	return result
end function

/* IupText and IupScintilla utilities */
--void IupTextConvertLinColToPos(Ihandle* ih, int lin, int col, int *pos);
public procedure IupTextConvertLinColToPos(atom ih, atom lin, atom col, atom pos)
	c_proc( xIupTextConvertLinColToPos, {ih,lin,col,pos} )
end procedure

--void IupTextConvertPosToLinCol(Ihandle* ih, int pos, int *lin, int *col);
public procedure IupTextConvertPosToLinCol(atom ih, atom pos, atom lin, atom col)
	c_proc( xIupTextConvertPosToLinCol, {ih,pos,lin,col} )
end procedure

/* IupText, IupList, IupTree, IupMatrix and IupScintilla utility */
--int IupConvertXYToPos(Ihandle* ih, int x, int y);
public function IupConvertXYToPos(atom ih, atom x, atom y)
	atom result = c_func( xIupConvertXYToPos, {ih,x,y} )
	return result
end function

/* OLD names, kept for backward compatibility, will never be removed. */
--void IupStoreGlobal(const char* name, const char* value);
public procedure IupStoreGlobal(object name = NULL, object value = NULL)
	if sequence(name) then name = allocate_string(name) end if
	if sequence(value) then value = allocate_string(value) end if
	c_proc( xIupStoreGlobal, {name,value} )
end procedure

--void IupStoreAttribute(Ihandle* ih, const char* name, const char* value);
public procedure IupStoreAttribute(atom ih, object name = NULL, object value = NULL)
	if sequence(name) then name = allocate_string(name) end if
	if sequence(value) then value = allocate_string(value) end if
	c_proc( xIupStoreAttribute, {ih,name,value} )
end procedure

--void IupStoreAttributeId(Ihandle *ih, const char* name, int id, const char *value);
public procedure IupStoreAttributeId(atom ih, object name = NULL, atom id, object value = NULL)
	if sequence(name) then name = allocate_string(name) end if
	if sequence(value) then value = allocate_string(value) end if
	c_proc( xIupStoreAttributeId, {ih,name,id,value} )
end procedure

--void IupStoreAttributeId2(Ihandle* ih, const char* name, int lin, int col, const char* value);
public procedure IupStoreAttributeId2(atom ih, object name = NULL, atom lin, atom col, object value = NULL)
	if sequence(name) then name = allocate_string(name) end if
	if sequence(value) then value = allocate_string(value) end if
	c_proc( xIupStoreAttributeId2, {ih,name,lin,col,value} )
end procedure

/* IupTree utilities */
--int IupTreeSetUserId(Ihandle* ih, int id, void* userid);
public function IupTreeSetUserId(atom ih, atom id, atom userid)
	atom result = c_func( xIupTreeSetUserId, {ih,id,userid} )
	return result
end function

--void* IupTreeGetUserId(Ihandle* ih, int id);
public function IupTreeGetUserId(atom ih, atom id)
	atom result = c_func( xIupTreeGetUserId, {ih,id} )
	return result
end function

--int IupTreeGetId(Ihandle* ih, void *userid);
public function IupTreeGetId(atom ih, atom userid)
	atom result = c_func( xIupTreeGetId, {ih,userid} )
	return result
end function

--void IupTreeSetAttributeHandle(Ihandle* ih, const char* name, int id, Ihandle* ih_named);
public procedure IupTreeSetAttributeHandle(atom ih, object name = NULL, atom id, atom ih_named)
	if sequence(name) then name = allocate_string(name) end if
	c_proc( xIupTreeSetAttributeHandle, {ih,name,id,ih_named} )
end procedure

/* DEPRECATED IupTree utilities, use Iup*AttributeId functions. It will be removed in a future version.  */
--void IupTreeSetAttribute(Ihandle* ih, const char* name, int id, const char* value);
public procedure IupTreeSetAttribute(atom ih, object name = NULL, atom id, object value = NULL)
	if sequence(name) then name = allocate_string(name) end if
	if sequence(value) then value = allocate_string(value) end if
	c_proc( xIupTreeSetAttribute, {ih,name,id,value} )
end procedure

--void IupTreeStoreAttribute(Ihandle* ih, const char* name, int id, const char* value);
public procedure IupTreeStoreAttribute(atom ih, object name = NULL, atom id, object value = NULL)
	if sequence(name) then name = allocate_string(name) end if
	if sequence(value) then value = allocate_string(value) end if
	c_proc( xIupTreeStoreAttribute, {ih,name,id,value} )
end procedure

--char* IupTreeGetAttribute(Ihandle* ih, const char* name, int id);
public function IupTreeGetAttribute(atom ih, object name = NULL, atom id)
	if sequence(name) then name = allocate_string(name) end if
	atom ptr = c_func( xIupTreeGetAttribute, {ih,name,id} )
	sequence str = ""
	if ptr != NULL then str = peek_string( ptr ) end if
	return str
end function

--int IupTreeGetInt(Ihandle* ih, const char* name, int id);
public function IupTreeGetInt(atom ih, object name = NULL, atom id)
	if sequence(name) then name = allocate_string(name) end if
	atom result = c_func( xIupTreeGetInt, {ih,name,id} )
	return result
end function

--float IupTreeGetFloat(Ihandle* ih, const char* name, int id);
public function IupTreeGetFloat(atom ih, object name = NULL, atom id)
	if sequence(name) then name = allocate_string(name) end if
	atom result = c_func( xIupTreeGetFloat, {ih,name,id} )
	return result
end function

/* DEPRECATED callback management. It will be removed in a future version. */
--const char* IupGetActionName(void);
public function IupGetActionName()
	atom result = c_func( xIupGetActionName, {} )
	return result
end function

/* DEPRECATED font names. It will be removed in a future version.  */
--char* IupMapFont(const char *iupfont);
public function IupMapFont(object iupfont = NULL)
	if sequence(iupfont) then iupfont = allocate_string(iupfont) end if
	atom ptr = c_func( xIupMapFont, {iupfont} )
	sequence str = ""
	if ptr != NULL then str = peek_string( ptr ) end if
	return str
end function

--char* IupUnMapFont(const char *driverfont);
public function IupUnMapFont(object driverfont = NULL)
	if sequence(driverfont) then driverfont = allocate_string(driverfont) end if
	atom ptr = c_func( xIupUnMapFont, {driverfont} )
	sequence str = ""
	if ptr != NULL then str = peek_string( ptr ) end if
	return str
end function

/************************************************************************/
/*                      Pre-defined dialogs                           */
/************************************************************************/
--Ihandle* IupFileDlg(void);
public function IupFileDlg()
	atom result = c_func( xIupFileDlg, {} )
	return result
end function

--Ihandle* IupMessageDlg(void);
public function IupMessageDlg()
	atom result = c_func( xIupMessageDlg, {} )
	return result
end function

--Ihandle* IupColorDlg(void);
public function IupColorDlg()
	atom result = c_func( xIupColorDlg, {} )
	return result
end function

--Ihandle* IupFontDlg(void);
public function IupFontDlg()
	atom result = c_func( xIupFontDlg, {} )
	return result
end function

--Ihandle* IupProgressDlg(void);
public function IupProgressDlg()
	atom result = c_func( xIupProgressDlg, {} )
	return result
end function

--int IupGetFile(char *arq);
public function IupGetFile(atom arq)
	atom result = c_func( xIupGetFile, {arq} )
	return result
end function

--void IupMessage(const char *title, const char *msg);
public procedure IupMessage(object title = NULL, object msg = NULL)
	if sequence(title) then title = allocate_string(title) end if
	if sequence(msg) then msg = allocate_string(msg) end if
	c_proc( xIupMessage, {title,msg} )
end procedure

--int IupAlarm(const char *title, const char *msg, const char *b1, const char *b2, const char *b3);
public function IupAlarm(object title = NULL, object msg = NULL, object b1 = NULL, object b2 = NULL, object b3 = NULL)
	if sequence(title) then title = allocate_string(title) end if
	if sequence(msg) then msg = allocate_string(msg) end if
	if sequence(b1) then b1 = allocate_string(b1) end if
	if sequence(b2) then b2 = allocate_string(b2) end if
	if sequence(b3) then b3 = allocate_string(b3) end if
	atom result = c_func( xIupAlarm, {title,msg,b1,b2,b3} )
	return result
end function

--int IupListDialog(int type, const char *title, int size, const char** list,  int op, int max_col, int max_lin, int* marks);
public function IupListDialog(atom _type, object title = NULL, atom size, sequence list = {}, atom op, atom max_col, atom max_lin, atom marks)
	if sequence(title) then title = allocate_string(title) end if
	atom p_list = allocate_string_pointer_array(list)
	atom result = c_func( xIupListDialog, {_type,title,size,p_list,op,max_col,max_lin,marks} )
	free(p_list)
	return result
end function

--int IupGetText(const char* title, char* text);
public function IupGetText(object title = NULL, atom text)
	if sequence(title) then title = allocate_string(title) end if
	atom result = c_func( xIupGetText, {title,text} )
	return result
end function

--int IupGetColor(int x, int y, unsigned char* r, unsigned char* g, unsigned char* b);
public function IupGetColor(atom x, atom y)
	atom rgb = allocate_data( sizeof(C_INT) * 3, 1 )
	atom r = rgb + sizeof(C_INT) * 0
	atom g = rgb + sizeof(C_INT) * 1
	atom b = rgb + sizeof(C_INT) * 2
	atom result = c_func( xIupGetColor, {x,y,r,g,b} )
	if result = 1 then return peek({ rgb, 3 }) end if
	return {}
end function

--int IupGetParamv(const char* title, Iparamcb action, void* user_data, const char* format, int param_count, int param_extra, void** param_data);
public function IupGetParam(object title = NULL, atom action, atom user_data, object format = NULL, atom param_count, atom param_extra, sequence param_data = {})
	if sequence(title) then title = allocate_string(title) end if
	if sequence(format) then format = allocate_string(format) end if
	atom p_param_data = allocate_pointer_array(param_data)
	atom result = c_func( xIupGetParam, {title,action,user_data,format,param_count,param_extra,p_param_data} )
	free(p_param_data)
	return result
end function

--Ihandle* IupParamf(const char* format);
public function IupParamf(object format = NULL)
	if sequence(format) then format = allocate_string(format) end if
	atom result = c_func( xIupParamf, {format} )
	return result
end function

--Ihandle* IupParamBox(Ihandle* parent, Ihandle** params, int count);
public function IupParamBox(atom parent, atom params, atom count)
	atom result = c_func( xIupParamBox, {parent,params,count} )
	return result
end function

--Ihandle* IupLayoutDialog(Ihandle* dialog);
public function IupLayoutDialog(atom dialog)
	atom result = c_func( xIupLayoutDialog, {dialog} )
	return result
end function

--Ihandle* IupElementPropertiesDialog(Ihandle* elem);
public function IupElementPropertiesDialog(atom elem)
	atom result = c_func( xIupElementPropertiesDialog, {elem} )
	return result
end function

/************************************************************************/
/*                   Common Flags and Return Values                     */
/************************************************************************/
public constant IUP_ERROR = 1
public constant IUP_NOERROR = 0
public constant IUP_OPENED = -1
public constant IUP_INVALID = -1
public constant IUP_INVALID_ID = -10
/************************************************************************/
/*                   Callback Return Values                             */
/************************************************************************/
public constant IUP_IGNORE = -1
public constant IUP_DEFAULT = -2
public constant IUP_CLOSE = -3
public constant IUP_CONTINUE = -4
/************************************************************************/
/*           IupPopup and IupShowXY Parameter Values                    */
/************************************************************************/
public constant IUP_CENTER = 0xFFFF /* 65535 */
public constant IUP_LEFT = 0xFFFE /* 65534 */
public constant IUP_RIGHT = 0xFFFD /* 65533 */
public constant IUP_MOUSEPOS = 0xFFFC /* 65532 */
public constant IUP_CURRENT = 0xFFFB /* 65531 */
public constant IUP_CENTERPARENT = 0xFFFA /* 65530 */
public constant IUP_TOP = IUP_LEFT
public constant IUP_BOTTOM = IUP_RIGHT
/************************************************************************/
/*               SHOW_CB Callback Values                                */
/************************************************************************/
public enum
	IUP_SHOW = 0,
	IUP_RESTORE,
	IUP_MINIMIZE,
	IUP_MAXIMIZE,
	IUP_HIDE,
$
/************************************************************************/
/*               SCROLL_CB Callback Values                              */
/************************************************************************/
public enum
	IUP_SBUP = 0,
	IUP_SBDN,
	IUP_SBPGUP,
	IUP_SBPGDN,
	IUP_SBPOSV,
	IUP_SBDRAGV,
	IUP_SBLEFT,
	IUP_SBRIGHT,
	IUP_SBPGLEFT,
	IUP_SBPGRIGHT,
	IUP_SBPOSH,
	IUP_SBDRAGH,
$
/************************************************************************/
/*               Mouse Button Values and Macros                         */
/************************************************************************/
public constant IUP_BUTTON1 = '1'
public constant IUP_BUTTON2 = '2'
public constant IUP_BUTTON3 = '3'
public constant IUP_BUTTON4 = '4'
public constant IUP_BUTTON5 = '5'
/* Old definitions for backward compatibility */
/************************************************************************/
/*                      Pre-Defined Masks                               */
/************************************************************************/
public constant IUP_MASK_FLOAT = "[+/-]?(/d+/.?/d*|/./d+)"
public constant IUP_MASK_UFLOAT = "(/d+/.?/d*|/./d+)"
public constant IUP_MASK_EFLOAT = "[+/-]?(/d+/.?/d*|/./d+)([eE][+/-]?/d+)?"
public constant IUP_MASK_FLOATCOMMA = "[+/-]?(/d+/,?/d*|/,/d+)"
public constant IUP_MASK_UFLOATCOMMA = "(/d+/,?/d*|/,/d+)"
public constant IUP_MASK_INT = "[+/-]?/d+"
public constant IUP_MASK_UINT = "/d+"
/* Old definitions for backward compatibility */
public constant IUPMASK_FLOAT = IUP_MASK_FLOAT
public constant IUPMASK_UFLOAT = IUP_MASK_UFLOAT
public constant IUPMASK_EFLOAT = IUP_MASK_EFLOAT
public constant IUPMASK_INT = IUP_MASK_INT
public constant IUPMASK_UINT = IUP_MASK_UINT
/************************************************************************/
/*                   IupGetParam Callback situations                    */
/************************************************************************/
public constant IUP_GETPARAM_BUTTON1 = -1
public constant IUP_GETPARAM_INIT = -2
public constant IUP_GETPARAM_BUTTON2 = -3
public constant IUP_GETPARAM_BUTTON3 = -4
public constant IUP_GETPARAM_CLOSE = -5
public constant IUP_GETPARAM_OK = IUP_GETPARAM_BUTTON1
public constant IUP_GETPARAM_CANCEL = IUP_GETPARAM_BUTTON2
public constant IUP_GETPARAM_HELP = IUP_GETPARAM_BUTTON3
/************************************************************************/
/*                   Record Input Modes                                 */
/************************************************************************/
public enum
	IUP_RECBINARY = 0,
	IUP_RECTEXT,
$
/************************************************************************/
/*              Replacement for the WinMain in Windows,                 */
/*        this allows the application to start from "main".             */
/*        Used only for Watcom.                                         */
/************************************************************************/

