namespace iup_config


include std/dll.e
include std/machine.e

atom iup = open_dll({ "iup.dll", "libiup.so", "libiup.dylib" })


public constant -- function delcarations
	xIupConfig                        = define_c_func( iup, "+IupConfig", {}, C_POINTER ),
	xIupConfigLoad                    = define_c_func( iup, "+IupConfigLoad", {C_POINTER}, C_INT ),
	xIupConfigSave                    = define_c_func( iup, "+IupConfigSave", {C_POINTER}, C_INT ),
	xIupConfigSetVariableStr          = define_c_proc( iup, "+IupConfigSetVariableStr", {C_POINTER,C_POINTER,C_POINTER,C_POINTER} ),
	xIupConfigSetVariableStrId        = define_c_proc( iup, "+IupConfigSetVariableStrId", {C_POINTER,C_POINTER,C_POINTER,C_INT,C_POINTER} ),
	xIupConfigSetVariableInt          = define_c_proc( iup, "+IupConfigSetVariableInt", {C_POINTER,C_POINTER,C_POINTER,C_INT} ),
	xIupConfigSetVariableIntId        = define_c_proc( iup, "+IupConfigSetVariableIntId", {C_POINTER,C_POINTER,C_POINTER,C_INT,C_INT} ),
	xIupConfigSetVariableDouble       = define_c_proc( iup, "+IupConfigSetVariableDouble", {C_POINTER,C_POINTER,C_POINTER,C_DOUBLE} ),
	xIupConfigSetVariableDoubleId     = define_c_proc( iup, "+IupConfigSetVariableDoubleId", {C_POINTER,C_POINTER,C_POINTER,C_INT,C_DOUBLE} ),
	xIupConfigGetVariableStr          = define_c_func( iup, "+IupConfigGetVariableStr", {C_POINTER,C_POINTER,C_POINTER}, C_POINTER ),
	xIupConfigGetVariableStrId        = define_c_func( iup, "+IupConfigGetVariableStrId", {C_POINTER,C_POINTER,C_POINTER,C_INT}, C_POINTER ),
	xIupConfigGetVariableInt          = define_c_func( iup, "+IupConfigGetVariableInt", {C_POINTER,C_POINTER,C_POINTER}, C_INT ),
	xIupConfigGetVariableIntId        = define_c_func( iup, "+IupConfigGetVariableIntId", {C_POINTER,C_POINTER,C_POINTER,C_INT}, C_INT ),
	xIupConfigGetVariableDouble       = define_c_func( iup, "+IupConfigGetVariableDouble", {C_POINTER,C_POINTER,C_POINTER}, C_DOUBLE ),
	xIupConfigGetVariableDoubleId     = define_c_func( iup, "+IupConfigGetVariableDoubleId", {C_POINTER,C_POINTER,C_POINTER,C_INT}, C_DOUBLE ),
	xIupConfigGetVariableStrDef       = define_c_func( iup, "+IupConfigGetVariableStrDef", {C_POINTER,C_POINTER,C_POINTER,C_POINTER}, C_POINTER ),
	xIupConfigGetVariableStrIdDef     = define_c_func( iup, "+IupConfigGetVariableStrIdDef", {C_POINTER,C_POINTER,C_POINTER,C_INT,C_POINTER}, C_POINTER ),
	xIupConfigGetVariableIntDef       = define_c_func( iup, "+IupConfigGetVariableIntDef", {C_POINTER,C_POINTER,C_POINTER,C_INT}, C_INT ),
	xIupConfigGetVariableIntIdDef     = define_c_func( iup, "+IupConfigGetVariableIntIdDef", {C_POINTER,C_POINTER,C_POINTER,C_INT,C_INT}, C_INT ),
	xIupConfigGetVariableDoubleDef    = define_c_func( iup, "+IupConfigGetVariableDoubleDef", {C_POINTER,C_POINTER,C_POINTER,C_DOUBLE}, C_DOUBLE ),
	xIupConfigGetVariableDoubleIdDef  = define_c_func( iup, "+IupConfigGetVariableDoubleIdDef", {C_POINTER,C_POINTER,C_POINTER,C_INT,C_DOUBLE}, C_DOUBLE ),
	xIupConfigRecentInit              = define_c_proc( iup, "+IupConfigRecentInit", {C_POINTER,C_POINTER,C_POINTER,C_INT} ),
	xIupConfigRecentUpdate            = define_c_proc( iup, "+IupConfigRecentUpdate", {C_POINTER,C_POINTER} ),
	xIupConfigDialogShow              = define_c_proc( iup, "+IupConfigDialogShow", {C_POINTER,C_POINTER,C_POINTER} ),
	xIupConfigDialogClosed            = define_c_proc( iup, "+IupConfigDialogClosed", {C_POINTER,C_POINTER,C_POINTER} ),
$

--Ihandle* IupConfig(void);
public function IupConfig()
	atom result = c_func( xIupConfig, {} )
	return result
end function

--int IupConfigLoad(Ihandle* ih);
public function IupConfigLoad(atom ih)
	atom result = c_func( xIupConfigLoad, {ih} )
	return result
end function

--int IupConfigSave(Ihandle* ih);
public function IupConfigSave(atom ih)
	atom result = c_func( xIupConfigSave, {ih} )
	return result
end function

/****************************************************************/
--void IupConfigSetVariableStr(Ihandle* ih, const char* group, const char* key, const char* value);
public procedure IupConfigSetVariableStr(atom ih, object group = NULL, object key = NULL, object value = NULL)
	if sequence(group) then group = allocate_string(group) end if
	if sequence(key) then key = allocate_string(key) end if
	if sequence(value) then value = allocate_string(value) end if
	c_proc( xIupConfigSetVariableStr, {ih,group,key,value} )
end procedure

--void IupConfigSetVariableStrId(Ihandle* ih, const char* group, const char* key, int id, const char* value);
public procedure IupConfigSetVariableStrId(atom ih, object group = NULL, object key = NULL, atom id, object value = NULL)
	if sequence(group) then group = allocate_string(group) end if
	if sequence(key) then key = allocate_string(key) end if
	if sequence(value) then value = allocate_string(value) end if
	c_proc( xIupConfigSetVariableStrId, {ih,group,key,id,value} )
end procedure

--void IupConfigSetVariableInt(Ihandle* ih, const char* group, const char* key, int value);
public procedure IupConfigSetVariableInt(atom ih, object group = NULL, object key = NULL, atom value)
	if sequence(group) then group = allocate_string(group) end if
	if sequence(key) then key = allocate_string(key) end if
	c_proc( xIupConfigSetVariableInt, {ih,group,key,value} )
end procedure

--void IupConfigSetVariableIntId(Ihandle* ih, const char* group, const char* key, int id, int value);
public procedure IupConfigSetVariableIntId(atom ih, object group = NULL, object key = NULL, atom id, atom value)
	if sequence(group) then group = allocate_string(group) end if
	if sequence(key) then key = allocate_string(key) end if
	c_proc( xIupConfigSetVariableIntId, {ih,group,key,id,value} )
end procedure

--void IupConfigSetVariableDouble(Ihandle* ih, const char* group, const char* key, double value);
public procedure IupConfigSetVariableDouble(atom ih, object group = NULL, object key = NULL, atom value)
	if sequence(group) then group = allocate_string(group) end if
	if sequence(key) then key = allocate_string(key) end if
	c_proc( xIupConfigSetVariableDouble, {ih,group,key,value} )
end procedure

--void IupConfigSetVariableDoubleId(Ihandle* ih, const char* group, const char* key, int id, double value);
public procedure IupConfigSetVariableDoubleId(atom ih, object group = NULL, object key = NULL, atom id, atom value)
	if sequence(group) then group = allocate_string(group) end if
	if sequence(key) then key = allocate_string(key) end if
	c_proc( xIupConfigSetVariableDoubleId, {ih,group,key,id,value} )
end procedure

--const char* IupConfigGetVariableStr(Ihandle* ih, const char* group, const char* key);
public function IupConfigGetVariableStr(atom ih, object group = NULL, object key = NULL)
	if sequence(group) then group = allocate_string(group) end if
	if sequence(key) then key = allocate_string(key) end if
	atom result = c_func( xIupConfigGetVariableStr, {ih,group,key} )
	return result
end function

--const char* IupConfigGetVariableStrId(Ihandle* ih, const char* group, const char* key, int id);
public function IupConfigGetVariableStrId(atom ih, object group = NULL, object key = NULL, atom id)
	if sequence(group) then group = allocate_string(group) end if
	if sequence(key) then key = allocate_string(key) end if
	atom result = c_func( xIupConfigGetVariableStrId, {ih,group,key,id} )
	return result
end function

--int IupConfigGetVariableInt(Ihandle* ih, const char* group, const char* key);
public function IupConfigGetVariableInt(atom ih, object group = NULL, object key = NULL)
	if sequence(group) then group = allocate_string(group) end if
	if sequence(key) then key = allocate_string(key) end if
	atom result = c_func( xIupConfigGetVariableInt, {ih,group,key} )
	return result
end function

--int IupConfigGetVariableIntId(Ihandle* ih, const char* group, const char* key, int id);
public function IupConfigGetVariableIntId(atom ih, object group = NULL, object key = NULL, atom id)
	if sequence(group) then group = allocate_string(group) end if
	if sequence(key) then key = allocate_string(key) end if
	atom result = c_func( xIupConfigGetVariableIntId, {ih,group,key,id} )
	return result
end function

--double IupConfigGetVariableDouble(Ihandle* ih, const char* group, const char* key);
public function IupConfigGetVariableDouble(atom ih, object group = NULL, object key = NULL)
	if sequence(group) then group = allocate_string(group) end if
	if sequence(key) then key = allocate_string(key) end if
	atom result = c_func( xIupConfigGetVariableDouble, {ih,group,key} )
	return result
end function

--double IupConfigGetVariableDoubleId(Ihandle* ih, const char* group, const char* key, int id);
public function IupConfigGetVariableDoubleId(atom ih, object group = NULL, object key = NULL, atom id)
	if sequence(group) then group = allocate_string(group) end if
	if sequence(key) then key = allocate_string(key) end if
	atom result = c_func( xIupConfigGetVariableDoubleId, {ih,group,key,id} )
	return result
end function

--const char* IupConfigGetVariableStrDef(Ihandle* ih, const char* group, const char* key, const char* def);
public function IupConfigGetVariableStrDef(atom ih, object group = NULL, object key = NULL, object def = NULL)
	if sequence(group) then group = allocate_string(group) end if
	if sequence(key) then key = allocate_string(key) end if
	if sequence(def) then def = allocate_string(def) end if
	atom result = c_func( xIupConfigGetVariableStrDef, {ih,group,key,def} )
	return result
end function

--const char* IupConfigGetVariableStrIdDef(Ihandle* ih, const char* group, const char* key, int id, const char* def);
public function IupConfigGetVariableStrIdDef(atom ih, object group = NULL, object key = NULL, atom id, object def = NULL)
	if sequence(group) then group = allocate_string(group) end if
	if sequence(key) then key = allocate_string(key) end if
	if sequence(def) then def = allocate_string(def) end if
	atom result = c_func( xIupConfigGetVariableStrIdDef, {ih,group,key,id,def} )
	return result
end function

--int IupConfigGetVariableIntDef(Ihandle* ih, const char* group, const char* key, int def);
public function IupConfigGetVariableIntDef(atom ih, object group = NULL, object key = NULL, atom def)
	if sequence(group) then group = allocate_string(group) end if
	if sequence(key) then key = allocate_string(key) end if
	atom result = c_func( xIupConfigGetVariableIntDef, {ih,group,key,def} )
	return result
end function

--int IupConfigGetVariableIntIdDef(Ihandle* ih, const char* group, const char* key, int id, int def);
public function IupConfigGetVariableIntIdDef(atom ih, object group = NULL, object key = NULL, atom id, atom def)
	if sequence(group) then group = allocate_string(group) end if
	if sequence(key) then key = allocate_string(key) end if
	atom result = c_func( xIupConfigGetVariableIntIdDef, {ih,group,key,id,def} )
	return result
end function

--double IupConfigGetVariableDoubleDef(Ihandle* ih, const char* group, const char* key, double def);
public function IupConfigGetVariableDoubleDef(atom ih, object group = NULL, object key = NULL, atom def)
	if sequence(group) then group = allocate_string(group) end if
	if sequence(key) then key = allocate_string(key) end if
	atom result = c_func( xIupConfigGetVariableDoubleDef, {ih,group,key,def} )
	return result
end function

--double IupConfigGetVariableDoubleIdDef(Ihandle* ih, const char* group, const char* key, int id, double def);
public function IupConfigGetVariableDoubleIdDef(atom ih, object group = NULL, object key = NULL, atom id, atom def)
	if sequence(group) then group = allocate_string(group) end if
	if sequence(key) then key = allocate_string(key) end if
	atom result = c_func( xIupConfigGetVariableDoubleIdDef, {ih,group,key,id,def} )
	return result
end function

/****************************************************************/
--void IupConfigRecentInit(Ihandle* ih, Ihandle* menu, Icallback recent_cb, int max_recent);
public procedure IupConfigRecentInit(atom ih, atom menu, atom recent_cb, atom max_recent)
	c_proc( xIupConfigRecentInit, {ih,menu,recent_cb,max_recent} )
end procedure

--void IupConfigRecentUpdate(Ihandle* ih, const char* filename);
public procedure IupConfigRecentUpdate(atom ih, object filename = NULL)
	if sequence(filename) then filename = allocate_string(filename) end if
	c_proc( xIupConfigRecentUpdate, {ih,filename} )
end procedure

--void IupConfigDialogShow(Ihandle* ih, Ihandle* dialog, const char* name);
public procedure IupConfigDialogShow(atom ih, atom dialog, object name = NULL)
	if sequence(name) then name = allocate_string(name) end if
	c_proc( xIupConfigDialogShow, {ih,dialog,name} )
end procedure

--void IupConfigDialogClosed(Ihandle* ih, Ihandle* dialog, const char* name);
public procedure IupConfigDialogClosed(atom ih, atom dialog, object name = NULL)
	if sequence(name) then name = allocate_string(name) end if
	c_proc( xIupConfigDialogClosed, {ih,dialog,name} )
end procedure


