namespace iup_plot


include std/dll.e
include std/machine.e

atom iup_plot = open_dll({ "iup_plot.dll", "libiup_plot.so", "libiup_plot.dylib" })


public constant -- function delcarations
	xIupPlotOpen                      = define_c_proc( iup_plot, "+IupPlotOpen", {} ),
	xIupPlot                          = define_c_func( iup_plot, "+IupPlot", {}, C_POINTER ),
	xIupPlotBegin                     = define_c_proc( iup_plot, "+IupPlotBegin", {C_POINTER,C_INT} ),
	xIupPlotAdd                       = define_c_proc( iup_plot, "+IupPlotAdd", {C_POINTER,C_DOUBLE,C_DOUBLE} ),
	xIupPlotAddStr                    = define_c_proc( iup_plot, "+IupPlotAddStr", {C_POINTER,C_POINTER,C_DOUBLE} ),
	xIupPlotAddSegment                = define_c_proc( iup_plot, "+IupPlotAddSegment", {C_POINTER,C_DOUBLE,C_DOUBLE} ),
	xIupPlotEnd                       = define_c_func( iup_plot, "+IupPlotEnd", {C_POINTER}, C_INT ),
	xIupPlotLoadData                  = define_c_func( iup_plot, "+IupPlotLoadData", {C_POINTER,C_POINTER,C_INT}, C_INT ),
	xIupPlotInsert                    = define_c_proc( iup_plot, "+IupPlotInsert", {C_POINTER,C_INT,C_INT,C_DOUBLE,C_DOUBLE} ),
	xIupPlotInsertStr                 = define_c_proc( iup_plot, "+IupPlotInsertStr", {C_POINTER,C_INT,C_INT,C_POINTER,C_DOUBLE} ),
	xIupPlotInsertSegment             = define_c_proc( iup_plot, "+IupPlotInsertSegment", {C_POINTER,C_INT,C_INT,C_DOUBLE,C_DOUBLE} ),
	xIupPlotInsertStrSamples          = define_c_proc( iup_plot, "+IupPlotInsertStrSamples", {C_POINTER,C_INT,C_INT,C_POINTER,C_POINTER,C_INT} ),
	xIupPlotInsertSamples             = define_c_proc( iup_plot, "+IupPlotInsertSamples", {C_POINTER,C_INT,C_INT,C_POINTER,C_POINTER,C_INT} ),
	xIupPlotAddSamples                = define_c_proc( iup_plot, "+IupPlotAddSamples", {C_POINTER,C_INT,C_POINTER,C_POINTER,C_INT} ),
	xIupPlotAddStrSamples             = define_c_proc( iup_plot, "+IupPlotAddStrSamples", {C_POINTER,C_INT,C_POINTER,C_POINTER,C_INT} ),
	xIupPlotGetSample                 = define_c_proc( iup_plot, "+IupPlotGetSample", {C_POINTER,C_INT,C_INT,C_POINTER,C_POINTER} ),
	xIupPlotGetSampleStr              = define_c_proc( iup_plot, "+IupPlotGetSampleStr", {C_POINTER,C_INT,C_INT,C_POINTER,C_POINTER} ),
	xIupPlotGetSampleSelection        = define_c_func( iup_plot, "+IupPlotGetSampleSelection", {C_POINTER,C_INT,C_INT}, C_INT ),
	xIupPlotSetSample                 = define_c_proc( iup_plot, "+IupPlotSetSample", {C_POINTER,C_INT,C_INT,C_DOUBLE,C_DOUBLE} ),
	xIupPlotSetSampleStr              = define_c_proc( iup_plot, "+IupPlotSetSampleStr", {C_POINTER,C_INT,C_INT,C_POINTER,C_DOUBLE} ),
	xIupPlotSetSampleSelection        = define_c_proc( iup_plot, "+IupPlotSetSampleSelection", {C_POINTER,C_INT,C_INT,C_INT} ),
	xIupPlotTransform                 = define_c_proc( iup_plot, "+IupPlotTransform", {C_POINTER,C_DOUBLE,C_DOUBLE,C_POINTER,C_POINTER} ),
	xIupPlotTransformTo               = define_c_proc( iup_plot, "+IupPlotTransformTo", {C_POINTER,C_DOUBLE,C_DOUBLE,C_POINTER,C_POINTER} ),
	xIupPlotFindSample                = define_c_func( iup_plot, "+IupPlotFindSample", {C_POINTER,C_DOUBLE,C_DOUBLE,C_POINTER,C_POINTER}, C_INT ),
	xIupPlotPaintTo                   = define_c_proc( iup_plot, "+IupPlotPaintTo", {C_POINTER,C_POINTER} ),
$

/* Initialize IupPlot widget class */
--void IupPlotOpen(void);
public procedure IupPlotOpen()
	c_proc( xIupPlotOpen, {} )
end procedure

/* Create an IupPlot widget instance */
--Ihandle* IupPlot(void);
public function IupPlot()
	atom result = c_func( xIupPlot, {} )
	return result
end function

/***********************************************/
/*           Additional API                    */
--void IupPlotBegin(Ihandle *ih, int strXdata);
public procedure IupPlotBegin(atom ih, atom strXdata)
	c_proc( xIupPlotBegin, {ih,strXdata} )
end procedure

--void IupPlotAdd(Ihandle *ih, double x, double y);
public procedure IupPlotAdd(atom ih, atom x, atom y)
	c_proc( xIupPlotAdd, {ih,x,y} )
end procedure

--void IupPlotAddStr(Ihandle *ih, const char* x, double y);
public procedure IupPlotAddStr(atom ih, object x = NULL, atom y)
	if sequence(x) then x = allocate_string(x) end if
	c_proc( xIupPlotAddStr, {ih,x,y} )
end procedure

--void IupPlotAddSegment(Ihandle *ih, double x, double y);
public procedure IupPlotAddSegment(atom ih, atom x, atom y)
	c_proc( xIupPlotAddSegment, {ih,x,y} )
end procedure

--int IupPlotEnd(Ihandle *ih);
public function IupPlotEnd(atom ih)
	atom result = c_func( xIupPlotEnd, {ih} )
	return result
end function

--int IupPlotLoadData(Ihandle* ih, const char* filename, int strXdata);
public function IupPlotLoadData(atom ih, object filename = NULL, atom strXdata)
	if sequence(filename) then filename = allocate_string(filename) end if
	atom result = c_func( xIupPlotLoadData, {ih,filename,strXdata} )
	return result
end function

/* available only when linking with "iupluaplot" */
--void IupPlotInsert(Ihandle *ih, int ds_index, int sample_index, double x, double y);
public procedure IupPlotInsert(atom ih, atom ds_index, atom sample_index, atom x, atom y)
	c_proc( xIupPlotInsert, {ih,ds_index,sample_index,x,y} )
end procedure

--void IupPlotInsertStr(Ihandle *ih, int ds_index, int sample_index, const char* x, double y);
public procedure IupPlotInsertStr(atom ih, atom ds_index, atom sample_index, object x = NULL, atom y)
	if sequence(x) then x = allocate_string(x) end if
	c_proc( xIupPlotInsertStr, {ih,ds_index,sample_index,x,y} )
end procedure

--void IupPlotInsertSegment(Ihandle *ih, int ds_index, int sample_index, double x, double y);
public procedure IupPlotInsertSegment(atom ih, atom ds_index, atom sample_index, atom x, atom y)
	c_proc( xIupPlotInsertSegment, {ih,ds_index,sample_index,x,y} )
end procedure

--void IupPlotInsertStrSamples(Ihandle* ih, int ds_index, int sample_index, const char** x, double* y, int count);
public procedure IupPlotInsertStrSamples(atom ih, atom ds_index, atom sample_index, sequence x = {}, atom y, atom count)
	atom p_x = allocate_string_pointer_array(x)
	c_proc( xIupPlotInsertStrSamples, {ih,ds_index,sample_index,p_x,y,count} )
	free(p_x)
end procedure

--void IupPlotInsertSamples(Ihandle* ih, int ds_index, int sample_index, double *x, double *y, int count);
public procedure IupPlotInsertSamples(atom ih, atom ds_index, atom sample_index, atom x, atom y, atom count)
	c_proc( xIupPlotInsertSamples, {ih,ds_index,sample_index,x,y,count} )
end procedure

--void IupPlotAddSamples(Ihandle* ih, int ds_index, double *x, double *y, int count);
public procedure IupPlotAddSamples(atom ih, atom ds_index, atom x, atom y, atom count)
	c_proc( xIupPlotAddSamples, {ih,ds_index,x,y,count} )
end procedure

--void IupPlotAddStrSamples(Ihandle* ih, int ds_index, const char** x, double* y, int count);
public procedure IupPlotAddStrSamples(atom ih, atom ds_index, sequence x = {}, atom y, atom count)
	atom p_x = allocate_string_pointer_array(x)
	c_proc( xIupPlotAddStrSamples, {ih,ds_index,p_x,y,count} )
	free(p_x)
end procedure

--void IupPlotGetSample(Ihandle* ih, int ds_index, int sample_index, double *x, double *y);
public procedure IupPlotGetSample(atom ih, atom ds_index, atom sample_index, atom x, atom y)
	c_proc( xIupPlotGetSample, {ih,ds_index,sample_index,x,y} )
end procedure

--void IupPlotGetSampleStr(Ihandle* ih, int ds_index, int sample_index, const char* *x, double *y);
public procedure IupPlotGetSampleStr(atom ih, atom ds_index, atom sample_index, sequence x = {}, atom y)
	atom p_x = allocate_string_pointer_array(x)
	c_proc( xIupPlotGetSampleStr, {ih,ds_index,sample_index,p_x,y} )
	free(p_x)
end procedure

--int IupPlotGetSampleSelection(Ihandle* ih, int ds_index, int sample_index);
public function IupPlotGetSampleSelection(atom ih, atom ds_index, atom sample_index)
	atom result = c_func( xIupPlotGetSampleSelection, {ih,ds_index,sample_index} )
	return result
end function

--void IupPlotSetSample(Ihandle* ih, int ds_index, int sample_index, double x, double y);
public procedure IupPlotSetSample(atom ih, atom ds_index, atom sample_index, atom x, atom y)
	c_proc( xIupPlotSetSample, {ih,ds_index,sample_index,x,y} )
end procedure

--void IupPlotSetSampleStr(Ihandle* ih, int ds_index, int sample_index, const char* x, double y);
public procedure IupPlotSetSampleStr(atom ih, atom ds_index, atom sample_index, object x = NULL, atom y)
	if sequence(x) then x = allocate_string(x) end if
	c_proc( xIupPlotSetSampleStr, {ih,ds_index,sample_index,x,y} )
end procedure

--void IupPlotSetSampleSelection(Ihandle* ih, int ds_index, int sample_index, int selected);
public procedure IupPlotSetSampleSelection(atom ih, atom ds_index, atom sample_index, atom selected)
	c_proc( xIupPlotSetSampleSelection, {ih,ds_index,sample_index,selected} )
end procedure

--void IupPlotTransform(Ihandle* ih, double x, double y, double *cnv_x, double *cnv_y);
public procedure IupPlotTransform(atom ih, atom x, atom y, atom cnv_x, atom cnv_y)
	c_proc( xIupPlotTransform, {ih,x,y,cnv_x,cnv_y} )
end procedure

--void IupPlotTransformTo(Ihandle* ih, double cnv_x, double cnv_y, double *x, double *y);
public procedure IupPlotTransformTo(atom ih, atom cnv_x, atom cnv_y, atom x, atom y)
	c_proc( xIupPlotTransformTo, {ih,cnv_x,cnv_y,x,y} )
end procedure

--int IupPlotFindSample(Ihandle* ih, double cnv_x, double cnv_y, int *ds_index, int *sample_index);
public function IupPlotFindSample(atom ih, atom cnv_x, atom cnv_y, atom ds_index, atom sample_index)
	atom result = c_func( xIupPlotFindSample, {ih,cnv_x,cnv_y,ds_index,sample_index} )
	return result
end function

--void IupPlotPaintTo(Ihandle *ih, struct _cdCanvas* cnv);
public procedure IupPlotPaintTo(atom ih, atom cnv)
	c_proc( xIupPlotPaintTo, {ih,cnv} )
end procedure

/***********************************************/

