namespace iup_pplot


include std/dll.e
include std/machine.e

atom iup_pplot = open_dll({ "iup_pplot.dll", "libiup_pplot.so", "libiup_pplot.dylib" })


public constant -- function delcarations
	xIupPPlotOpen                     = define_c_proc( iup_pplot, "+IupPPlotOpen", {} ),
	xIupPPlot                         = define_c_func( iup_pplot, "+IupPPlot", {}, C_POINTER ),
	xIupPPlotBegin                    = define_c_proc( iup_pplot, "+IupPPlotBegin", {C_POINTER,C_INT} ),
	xIupPPlotAdd                      = define_c_proc( iup_pplot, "+IupPPlotAdd", {C_POINTER,C_FLOAT,C_FLOAT} ),
	xIupPPlotAddStr                   = define_c_proc( iup_pplot, "+IupPPlotAddStr", {C_POINTER,C_POINTER,C_FLOAT} ),
	xIupPPlotEnd                      = define_c_func( iup_pplot, "+IupPPlotEnd", {C_POINTER}, C_INT ),
	xIupPPlotInsertStr                = define_c_proc( iup_pplot, "+IupPPlotInsertStr", {C_POINTER,C_INT,C_INT,C_POINTER,C_FLOAT} ),
	xIupPPlotInsert                   = define_c_proc( iup_pplot, "+IupPPlotInsert", {C_POINTER,C_INT,C_INT,C_FLOAT,C_FLOAT} ),
	xIupPPlotInsertStrPoints          = define_c_proc( iup_pplot, "+IupPPlotInsertStrPoints", {C_POINTER,C_INT,C_INT,C_POINTER,C_POINTER,C_INT} ),
	xIupPPlotInsertPoints             = define_c_proc( iup_pplot, "+IupPPlotInsertPoints", {C_POINTER,C_INT,C_INT,C_POINTER,C_POINTER,C_INT} ),
	xIupPPlotAddPoints                = define_c_proc( iup_pplot, "+IupPPlotAddPoints", {C_POINTER,C_INT,C_POINTER,C_POINTER,C_INT} ),
	xIupPPlotAddStrPoints             = define_c_proc( iup_pplot, "+IupPPlotAddStrPoints", {C_POINTER,C_INT,C_POINTER,C_POINTER,C_INT} ),
	xIupPPlotGetSample                = define_c_proc( iup_pplot, "+IupPPlotGetSample", {C_POINTER,C_INT,C_INT,C_POINTER,C_POINTER} ),
	xIupPPlotGetSampleStr             = define_c_proc( iup_pplot, "+IupPPlotGetSampleStr", {C_POINTER,C_INT,C_INT,C_POINTER,C_POINTER} ),
	xIupPPlotTransform                = define_c_proc( iup_pplot, "+IupPPlotTransform", {C_POINTER,C_FLOAT,C_FLOAT,C_POINTER,C_POINTER} ),
	xIupPPlotTransformTo              = define_c_proc( iup_pplot, "+IupPPlotTransformTo", {C_POINTER,C_INT,C_INT,C_POINTER,C_POINTER} ),
	xIupPPlotPaintTo                  = define_c_proc( iup_pplot, "+IupPPlotPaintTo", {C_POINTER,C_POINTER} ),
$

/* Initialize IupPPlot widget class */
--void IupPPlotOpen(void);
public procedure IupPPlotOpen()
	c_proc( xIupPPlotOpen, {} )
end procedure

/* Create an IupPPlot widget instance */
--Ihandle* IupPPlot(void);
public function IupPPlot()
	atom result = c_func( xIupPPlot, {} )
	return result
end function

/***********************************************/
/*           Additional API                    */
--void IupPPlotBegin(Ihandle *ih, int strXdata);
public procedure IupPPlotBegin(atom ih, atom strXdata)
	c_proc( xIupPPlotBegin, {ih,strXdata} )
end procedure

--void IupPPlotAdd(Ihandle *ih, float x, float y);
public procedure IupPPlotAdd(atom ih, atom x, atom y)
	c_proc( xIupPPlotAdd, {ih,x,y} )
end procedure

--void IupPPlotAddStr(Ihandle *ih, const char* x, float y);
public procedure IupPPlotAddStr(atom ih, object x = NULL, atom y)
	if sequence(x) then x = allocate_string(x) end if
	c_proc( xIupPPlotAddStr, {ih,x,y} )
end procedure

--int IupPPlotEnd(Ihandle *ih);
public function IupPPlotEnd(atom ih)
	atom result = c_func( xIupPPlotEnd, {ih} )
	return result
end function

--void IupPPlotInsertStr(Ihandle *ih, int index, int sample_index, const char* x, float y);
public procedure IupPPlotInsertStr(atom ih, atom index, atom sample_index, object x = NULL, atom y)
	if sequence(x) then x = allocate_string(x) end if
	c_proc( xIupPPlotInsertStr, {ih,index,sample_index,x,y} )
end procedure

--void IupPPlotInsert(Ihandle *ih, int index, int sample_index, float x, float y);
public procedure IupPPlotInsert(atom ih, atom index, atom sample_index, atom x, atom y)
	c_proc( xIupPPlotInsert, {ih,index,sample_index,x,y} )
end procedure

--void IupPPlotInsertStrPoints(Ihandle* ih, int index, int sample_index, const char** x, float* y, int count);
public procedure IupPPlotInsertStrPoints(atom ih, atom index, atom sample_index, sequence x = {}, atom y, atom count)
	atom p_x = allocate_string_pointer_array(x)
	c_proc( xIupPPlotInsertStrPoints, {ih,index,sample_index,p_x,y,count} )
	free(p_x)
end procedure

--void IupPPlotInsertPoints(Ihandle* ih, int index, int sample_index, float *x, float *y, int count);
public procedure IupPPlotInsertPoints(atom ih, atom index, atom sample_index, atom x, atom y, atom count)
	c_proc( xIupPPlotInsertPoints, {ih,index,sample_index,x,y,count} )
end procedure

--void IupPPlotAddPoints(Ihandle* ih, int index, float *x, float *y, int count);
public procedure IupPPlotAddPoints(atom ih, atom index, atom x, atom y, atom count)
	c_proc( xIupPPlotAddPoints, {ih,index,x,y,count} )
end procedure

--void IupPPlotAddStrPoints(Ihandle* ih, int index, const char** x, float* y, int count);
public procedure IupPPlotAddStrPoints(atom ih, atom index, sequence x = {}, atom y, atom count)
	atom p_x = allocate_string_pointer_array(x)
	c_proc( xIupPPlotAddStrPoints, {ih,index,p_x,y,count} )
	free(p_x)
end procedure

--void IupPPlotGetSample(Ihandle* ih, int index, int sample_index, float *x, float *y);
public procedure IupPPlotGetSample(atom ih, atom index, atom sample_index, atom x, atom y)
	c_proc( xIupPPlotGetSample, {ih,index,sample_index,x,y} )
end procedure

--void IupPPlotGetSampleStr(Ihandle* ih, int index, int sample_index, const char* *x, float *y);
public procedure IupPPlotGetSampleStr(atom ih, atom index, atom sample_index, sequence x = {}, atom y)
	atom p_x = allocate_string_pointer_array(x)
	c_proc( xIupPPlotGetSampleStr, {ih,index,sample_index,p_x,y} )
	free(p_x)
end procedure

--void IupPPlotTransform(Ihandle* ih, float x, float y, int *ix, int *iy);
public procedure IupPPlotTransform(atom ih, atom x, atom y, atom ix, atom iy)
	c_proc( xIupPPlotTransform, {ih,x,y,ix,iy} )
end procedure

--void IupPPlotTransformTo(Ihandle* ih, int x, int y, float *rx, float *ry);
public procedure IupPPlotTransformTo(atom ih, atom x, atom y, atom rx, atom ry)
	c_proc( xIupPPlotTransformTo, {ih,x,y,rx,ry} )
end procedure

--void IupPPlotPaintTo(Ihandle *ih, void *cnv);
public procedure IupPPlotPaintTo(atom ih, atom cnv)
	c_proc( xIupPPlotPaintTo, {ih,cnv} )
end procedure

/***********************************************/

