namespace iupcontrols


include std/dll.e
include std/machine.e

atom iupcontrols = open_dll({ "iupcontrols.dll", "libiupcontrols.so", "libiupcontrols.dylib" })


public constant -- function delcarations
	xIupControlsOpen                  = define_c_func( iupcontrols, "+IupControlsOpen", {}, C_INT ),
	xIupColorbar                      = define_c_func( iupcontrols, "+IupColorbar", {}, C_POINTER ),
	xIupCells                         = define_c_func( iupcontrols, "+IupCells", {}, C_POINTER ),
	xIupColorBrowser                  = define_c_func( iupcontrols, "+IupColorBrowser", {}, C_POINTER ),
	xIupGauge                         = define_c_func( iupcontrols, "+IupGauge", {}, C_POINTER ),
	xIupDial                          = define_c_func( iupcontrols, "+IupDial", {C_POINTER}, C_POINTER ),
	xIupMatrix                        = define_c_func( iupcontrols, "+IupMatrix", {C_POINTER}, C_POINTER ),
	xIupMatrixList                    = define_c_func( iupcontrols, "+IupMatrixList", {}, C_POINTER ),
	xIupMatSetAttribute               = define_c_proc( iupcontrols, "+IupMatSetAttribute", {C_POINTER,C_POINTER,C_INT,C_INT,C_POINTER} ),
	xIupMatStoreAttribute             = define_c_proc( iupcontrols, "+IupMatStoreAttribute", {C_POINTER,C_POINTER,C_INT,C_INT,C_POINTER} ),
	xIupMatGetAttribute               = define_c_func( iupcontrols, "+IupMatGetAttribute", {C_POINTER,C_POINTER,C_INT,C_INT}, C_POINTER ),
	xIupMatGetInt                     = define_c_func( iupcontrols, "+IupMatGetInt", {C_POINTER,C_POINTER,C_INT,C_INT}, C_INT ),
	xIupMatGetFloat                   = define_c_func( iupcontrols, "+IupMatGetFloat", {C_POINTER,C_POINTER,C_INT,C_INT}, C_FLOAT ),
$

--int IupControlsOpen(void);
public function IupControlsOpen()
	atom result = c_func( xIupControlsOpen, {} )
	return result
end function

--Ihandle* IupColorbar(void);
public function IupColorbar()
	atom result = c_func( xIupColorbar, {} )
	return result
end function

--Ihandle* IupCells(void);
public function IupCells()
	atom result = c_func( xIupCells, {} )
	return result
end function

--Ihandle *IupColorBrowser(void);
public function IupColorBrowser()
	atom result = c_func( xIupColorBrowser, {} )
	return result
end function

--Ihandle *IupGauge(void);
public function IupGauge()
	atom result = c_func( xIupGauge, {} )
	return result
end function

--Ihandle *IupDial(const char* type);
public function IupDial(object _type = NULL)
	if sequence(_type) then _type = allocate_string(_type) end if
	atom result = c_func( xIupDial, {_type} )
	return result
end function

--Ihandle* IupMatrix(const char *action);
public function IupMatrix(object action = NULL)
	if sequence(action) then action = allocate_string(action) end if
	atom result = c_func( xIupMatrix, {action} )
	return result
end function

--Ihandle* IupMatrixList(void);
public function IupMatrixList()
	atom result = c_func( xIupMatrixList, {} )
	return result
end function

/* IupMatrix utilities (DEPRECATED, use IupSetAttributeId2 functions). It will be removed in a future version. */
--void IupMatSetAttribute(Ihandle* ih, const char* name, int lin, int col, const char* value);
public procedure IupMatSetAttribute(atom ih, object name = NULL, atom lin, atom col, object value = NULL)
	if sequence(name) then name = allocate_string(name) end if
	if sequence(value) then value = allocate_string(value) end if
	c_proc( xIupMatSetAttribute, {ih,name,lin,col,value} )
end procedure

--void IupMatStoreAttribute(Ihandle* ih, const char* name, int lin, int col, const char* value);
public procedure IupMatStoreAttribute(atom ih, object name = NULL, atom lin, atom col, object value = NULL)
	if sequence(name) then name = allocate_string(name) end if
	if sequence(value) then value = allocate_string(value) end if
	c_proc( xIupMatStoreAttribute, {ih,name,lin,col,value} )
end procedure

--char* IupMatGetAttribute(Ihandle* ih, const char* name, int lin, int col);
public function IupMatGetAttribute(atom ih, object name = NULL, atom lin, atom col)
	if sequence(name) then name = allocate_string(name) end if
	atom ptr = c_func( xIupMatGetAttribute, {ih,name,lin,col} )
	sequence str = ""
	if ptr != NULL then str = peek_string( ptr ) end if
	return str
end function

--int IupMatGetInt(Ihandle* ih, const char* name, int lin, int col);
public function IupMatGetInt(atom ih, object name = NULL, atom lin, atom col)
	if sequence(name) then name = allocate_string(name) end if
	atom result = c_func( xIupMatGetInt, {ih,name,lin,col} )
	return result
end function

--float IupMatGetFloat(Ihandle* ih, const char* name, int lin, int col);
public function IupMatGetFloat(atom ih, object name = NULL, atom lin, atom col)
	if sequence(name) then name = allocate_string(name) end if
	atom result = c_func( xIupMatGetFloat, {ih,name,lin,col} )
	return result
end function

/* Used by IupColorbar */
public constant IUP_PRIMARY = -1
public constant IUP_SECONDARY = -2
/* available only when linking with "iupluamatrix" */

