namespace iupgl


include std/dll.e
include std/machine.e

atom iupgl = open_dll({ "iupgl.dll", "libiupgl.so", "libiupgl.dylib" })


public constant -- function delcarations
	xIupGLCanvasOpen                  = define_c_proc( iupgl, "+IupGLCanvasOpen", {} ),
	xIupGLCanvas                      = define_c_func( iupgl, "+IupGLCanvas", {C_POINTER}, C_POINTER ),
	xIupGLMakeCurrent                 = define_c_proc( iupgl, "+IupGLMakeCurrent", {C_POINTER} ),
	xIupGLIsCurrent                   = define_c_func( iupgl, "+IupGLIsCurrent", {C_POINTER}, C_INT ),
	xIupGLSwapBuffers                 = define_c_proc( iupgl, "+IupGLSwapBuffers", {C_POINTER} ),
	xIupGLPalette                     = define_c_proc( iupgl, "+IupGLPalette", {C_POINTER,C_INT,C_FLOAT,C_FLOAT,C_FLOAT} ),
	xIupGLUseFont                     = define_c_proc( iupgl, "+IupGLUseFont", {C_POINTER,C_INT,C_INT,C_INT} ),
	xIupGLWait                        = define_c_proc( iupgl, "+IupGLWait", {C_INT} ),
$

public constant IUP_BUFFER = "BUFFER"
public constant IUP_STEREO = "STEREO"
public constant IUP_BUFFER_SIZE = "BUFFER_SIZE"
public constant IUP_RED_SIZE = "RED_SIZE"
public constant IUP_GREEN_SIZE = "GREEN_SIZE"
public constant IUP_BLUE_SIZE = "BLUE_SIZE"
public constant IUP_ALPHA_SIZE = "ALPHA_SIZE"
public constant IUP_DEPTH_SIZE = "DEPTH_SIZE"
public constant IUP_STENCIL_SIZE = "STENCIL_SIZE"
public constant IUP_ACCUM_RED_SIZE = "ACCUM_RED_SIZE"
public constant IUP_ACCUM_GREEN_SIZE = "ACCUM_GREEN_SIZE"
public constant IUP_ACCUM_BLUE_SIZE = "ACCUM_BLUE_SIZE"
public constant IUP_ACCUM_ALPHA_SIZE = "ACCUM_ALPHA_SIZE"
/* Attribute values */
public constant IUP_DOUBLE = "DOUBLE"
public constant IUP_SINGLE = "SINGLE"
public constant IUP_INDEX = "INDEX"
public constant IUP_RGBA = "RGBA"
public constant IUP_YES = "YES"
public constant IUP_NO = "NO"
--void IupGLCanvasOpen(void);
public procedure IupGLCanvasOpen()
	c_proc( xIupGLCanvasOpen, {} )
end procedure

--Ihandle *IupGLCanvas(const char *action);
public function IupGLCanvas(object action = NULL)
	if sequence(action) then action = allocate_string(action) end if
	atom result = c_func( xIupGLCanvas, {action} )
	return result
end function

--void IupGLMakeCurrent(Ihandle* ih);
public procedure IupGLMakeCurrent(atom ih)
	c_proc( xIupGLMakeCurrent, {ih} )
end procedure

--int IupGLIsCurrent(Ihandle* ih);
public function IupGLIsCurrent(atom ih)
	atom result = c_func( xIupGLIsCurrent, {ih} )
	return result
end function

--void IupGLSwapBuffers(Ihandle* ih);
public procedure IupGLSwapBuffers(atom ih)
	c_proc( xIupGLSwapBuffers, {ih} )
end procedure

--void IupGLPalette(Ihandle* ih, int index, float r, float g, float b);
public procedure IupGLPalette(atom ih, atom index, atom r, atom g, atom b)
	c_proc( xIupGLPalette, {ih,index,r,g,b} )
end procedure

--void IupGLUseFont(Ihandle* ih, int first, int count, int list_base);
public procedure IupGLUseFont(atom ih, atom first, atom count, atom list_base)
	c_proc( xIupGLUseFont, {ih,first,count,list_base} )
end procedure

--void IupGLWait(int gl);
public procedure IupGLWait(atom gl)
	c_proc( xIupGLWait, {gl} )
end procedure


